#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_balcony_down(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("庭のあちこちに石のようなものが埋め込まれている。");
			if (Is(magic_circle_invoked)){
				message("石を結ぶようにして、巨大な魔法陣が浮かび上がっている。");
			}
			message("庭の中央には%nlが停まっている。", ni_car);
            return 1;
        case vi_backward:
        case vi_up:
        case vi_exit:
            move_area(ai_balcony);
            return 1;
        default:
            break;
        }
        break;
    case ni_car:
        switch (vid){
        case vi_look:
			message(noun_description(nid));
            message("荷台に%nlが積まれている。",
				    ni_drum);
			return 1;
        case vi_examine:
        case vi_remove:
        case vi_move:
        case vi_get:
        case vi_hit:
        case vi_kick:
        case vi_destroy:
        case vi_open:
        case vi_close:
			msg_too_far();
			return 1;
        default:
            break;
        }
        break;
    case ni_drum:
        switch (vid){
        case vi_look:
            message("荷台いっぱいに並んでいる。",
                    ni_drum);
            return 1;
        case vi_examine:
        case vi_remove:
        case vi_move:
        case vi_get:
        case vi_hit:
        case vi_kick:
        case vi_destroy:
        case vi_open:
        case vi_close:
        case vi_drink:
			msg_too_far();
			return 1;
        default:
            break;
        }
        break;
    default:
    	*exist = 0;
        break;
    }
    return 0;
}
