#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void describe_bed(void);

int area_bed(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			describe_bed();
            return 1;
        case vi_backward:
        case vi_down:
        case vi_exit:
            move_area(ai_boys_room);
            return 1;
        default:
            break;
        }
        break;
	case ni_bed:
        switch (vid){
		case vi_look:
			describe_bed();
			return 1;
		default:
			break;
		}
		break;
	case ni_ladder:
        // ここにいるということは梯子はベッドに掛かっている。
        switch (vid){
        case vi_examine:
            msg_nothing_special(); // msg_need_to_getをオーバライド
        case vi_get:
            msg_bootstrap();
            return 1;
        case vi_up:
            msg_multiple_climb();
            return 1;
        case vi_down:
            RedoArea(vi_down, ni_invalid);
        default:
            break;
        }
        break;
    case ni_mattress:
        switch (vid){
        case vi_look:
        case vi_examine:
            if (Not(diary_taken)){
                if (Not(mattress_moved)){
                    message("ベッドとマットレスの隙間に、何か見えている。");
                }
                else {
                    message("ベッドとマットレスの隙間に%nlがある。",
                            ni_diary);
                }
            }
			else {
				msg_nothing_any_more();
			}
            return 1;
        case vi_remove:
        case vi_move:
            TestAndSet(mattress_moved,
                       "マットレスを動かすと、ベッドとの隙間から何かが出てきた。",
                       "これ以上は動かない。");
            return 1;
        default:
            break;
        }
        break;
    case ni_plush_cat:
		ReturnIfHasItem;
		switch (vid){
		case vi_get:
			command_get_item(nid, fi_plush_cat_taken);
			return 1;
		default:
			break;
		}
		break;
    case ni_diary:
		ReturnIfHasItem;
		switch (vid){
		case vi_get:
			command_get_item(nid, fi_diary_taken);
			return 1;
		default:
			break;
		}
		break;
	default:
		*exist = 0;
        break;
    }
    return 0;
}


void describe_bed(void){
	message("ベッドには%nlが敷いてある。",
			ni_mattress);
	if (Not(plush_cat_taken)){
		message("%nnの上には%nlが転がっている。",
				ni_mattress, ni_plush_cat);		
	}
    if (Is(mattress_moved)){
        message("ベッドとマットレスの隙間に%nlがある。",
                ni_diary);
    }
}
