#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_bedroom(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("部屋の左右には、それぞれ%nlと%nlがある。",
					ni_chest, ni_bed);
            message("背後には廊下に続く扉がある。");
            return 1;
        case vi_backward:
        case vi_exit:
            EnterDoor(corridor_2f_r, bedroom);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
		}
		break;
    case ni_bed:
        switch (vid){
		case vi_look:
            message("ダブルベッドだ。");
			return 1;
		case vi_examine:
            if (Not(marble_found)){
                message("ベッドの下から%nlが出てきた。",
                        ni_marble);
                Set(marble_found);
            }
            else {
                message("もう何もないようだ。");
            }
			return 1;
		default:
			break;
		}
		break;
    case ni_marble:
        ReturnIfHasItem;
        if (Is(marble_taken) ||
            Not(marble_found))
        {
			ReturnNotExist;
		}
        switch (vid){
		case vi_get:
			command_get_item(nid, fi_marble_taken);
			return 1;
		default:
			break;
		}
		break;
    case ni_chest:
        switch (vid){
        case vi_look:
            message("%nlが並んだ箪笥だ。",
                    ni_drawer);
            return 1;
        case vi_examine:
            RedoArea(vi_examine, ni_drawer);
        case vi_open:
        case vi_close:
            RedoArea(vid, ni_drawer);
        default:
            break;
        }
        break;
    case ni_drawer:
        switch (vid){
        case vi_look:
        case vi_examine:
            message("外側に変わったところはない。");
            if (Is(bedroom_drawers_opened)){
                message("中は空だ。");
            }
            return 1;
        case vi_close:
            TestAndReset(bedroom_drawers_opened,
                       "引き出しを閉じた。",
                       "もう閉まっている。");
            return 1;
        case vi_open:
            TestAndSet(bedroom_drawers_opened,
                       "引き出しを開けた。",
                       "もう開いている。");
            return 1;
        case vi_move:
            if (Is(bedroom_drawers_opened)){
                RedoArea(vi_close, nid);
            }
            else {
                RedoArea(vi_open, nid);
            }
        default:
            break;
        }
        break;
    case ni_floor:
    case ni_wall:
    case ni_ceiling:
	case ni_window:
        break;
    default:
		*exist = 0;
        break;
    }
    return 0;
}

