#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void describe_bookshelf(void);

int area_bookshelf(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            describe_bookshelf();
            return 1;
        case vi_backward:
        case vi_down:
        case vi_exit:
            move_area(ai_library);
            return 1;
        default:
            break;
        }
        break;
	case ni_bookshelf:
        switch (vid){
		case vi_look:
            describe_bookshelf();
			return 1;
		default:
			break;
		}
		break;
	case ni_ladder:
        // ここにいるということは梯子は本棚に掛かっている。
        switch (vid){
        case vi_examine:
            msg_nothing_special(); // msg_need_to_getをオーバライド
        case vi_get:
            msg_bootstrap();
            return 1;
        case vi_up:
            msg_multiple_climb();
            return 1;
        case vi_down:
            RedoArea(vi_down, ni_invalid);
        default:
            break;
        }
        break;
    case ni_origami_plane:
		ReturnIfHasItem;
		switch (vid){
		case vi_get:
			command_get_item(nid, fi_origami_plane_taken);
			return 1;
		default:
			break;
		}
		break;
    case ni_wall:
        break;
	default:
		*exist = 0;
        break;
    }
    return 0;
}


void describe_bookshelf(void){
            if (Not(origami_plane_taken)){
                message("%nnの上には%nlが乗っている。",
                        ni_bookshelf, ni_origami_plane);		
            }
            else {
                message("%nnの上にはもう何もない。",
                        ni_bookshelf);
            }
}
