#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void exit_cave(void);
void temple_exploded(void);
void house_burning(void);
void show_ending_logo(void);
void go_ending(void);

int area_cave(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("ここは自然にできた洞窟のようだ。"
                    "奥の方に光が見える。"
                    "どうやら外に出られそうだ。");
            return 1;
		case vi_forward:
		case vi_exit:
			message("神殿の方からは、残ったドラム缶が爆発する音が聞こえてくる。"
					"あなたは炎に追われるようにして、洞窟の出口へと走った。");
            message("");
            exit_cave();
            return 1;
		case vi_backward:
			message("神殿の中はすっかり火が回っていて、"
					"とても引き返せない。");
//			move_area(ai_temple);
            return 1;
        default:
            break;

        }
        break;
    case ni_floor:
    case ni_wall:
    case ni_ceiling:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

void exit_cave(void){
    move_area(ai_under_cliff);
    set_wait_return_callback(temple_exploded);
}
void temple_exploded(void){
    move_area(ai_under_cliff);
    //    message("洞窟を出ると、そこは海岸だった。");
    message(""
            "洞窟の中からは、なおも爆発音が続き、"
            "やがて大音響と共に、崖上に炎の柱が立ち上った。");
    Set(temple_exploded);
    set_wait_return_callback(house_burning);
}
void house_burning(void){
    message(""
            "見守るうちに、屋敷の窓からも黒煙が上がり、"
            "まもなく火の手が上がった。"
            "そして、忌まわしいものに支配されていた屋敷は、"
            "すべてを浄化する炎の中に焼け落ちていった。");
    Set(house_burning);
    set_wait_return_callback(show_ending_logo);
}
void show_ending_logo(void){
    Set(the_end);
    set_wait_return_callback(go_ending);
}
void go_ending(void){
    move_to_ending();
}
