#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_cellar(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("左側には、洗濯室へ上がる%nlがある。"
                    "正面には小さな%nlがある。",
                    ni_stairs, ni_door);
            message("右側の壁は大きく崩れ、穴が空いている。");
            return 1;
		case vi_up:
		case vi_left:
		case vi_exit:
            Reset(save_forbidden);
            EnterDoor(laundry, laundry_cellar);
            return 1;
		case vi_right:
            move_area(ai_corridor_0f);
            return 1;
        case vi_forward:
            EnterDoor(boiler_room, boiler_room);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_forward, ni_invalid);
			return 1;
		}
        break;
    case ni_stairs:
        switch (vid){
        case vi_look:
        case vi_examine:
            break;
        case vi_use:
        case vi_up:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_floor:
        switch (vid){
        case vi_look:
        case vi_examine:
            message("床の上には%nlが落ちている。", ni_gun);
            return 1;
        default:
            break;
        }
        break;
    case ni_gun:
        switch (vid){
        case vi_look:
        case vi_examine:
            message("いったい何にやられたのか、銃身がぐにゃりと曲がっている。");
            return 1;
        case vi_get:
            message("持って行っても役に立ちそうにない。");
            return 1;
        case vi_use:
            message("とても撃てる状態ではない。");
            return 1;
        default:
            break;
        }
        break;
    case ni_wall:
    case ni_ceiling:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

