#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_corridor_1f_bl(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
	switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("正面と左に扉%nw%nwがある。",
                    ni_front_door, ni_left_door);
            
            if (Is(living_corridor_door_opened)){
                message("正面の扉は居間に通じている。");
            }
            if (Is(playroom_door_opened)){
                message("左の扉は遊戯室に通じている。");
			}
            return 1;
        case vi_forward:
            enter_door(ai_living, fi_living_corridor_door_opened);
			// 最初に居間に入るにはここの廊下から行くしかないので、
			// ここでイベントフラグを立てる
			if (Not(phone_call_stopped)){
				Set(phone_call_continued);
                msg_phone_call_started();
			}
            return 1;
        case vi_backward:
            move_area(ai_corridor_1f_fl);
            return 1;
        case vi_left:
            EnterDoor(playroom, playroom);
			return 1;
        default:
            break;
        }
        break;
    case ni_corridor:
        switch (vid){
        case vi_look:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
    case ni_door:
        msg_which_door();
        return 1;
    case ni_front_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_forward, ni_invalid);
		}
        break;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
		}
        break;
    default:
		*exist = 0;
        break;
    }
    return 0;
}

