#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_corridor_1f_br(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("背後から続く廊下は、前方で行き止まりになっている。");
            message("左右に扉%nw%nwが\\",
                    ni_left_door, ni_right_door);
            if (Is(kitchen_corridor_door_opened) &&
                Is(laundry_corridor_door_opened))
            {
                message("あり、それぞれぞれ台所と洗濯室に通じている。");
            }
            else if (Is(kitchen_corridor_door_opened)){
                message("あり、左側の扉は台所に通じている。");
            }
            else if (Is(laundry_corridor_door_opened)){
                message("あり、右側の扉は洗濯室に通じている。");
            }
            else {
                message("ある。");
            }
            return 1;
        case vi_backward:
            move_area(ai_corridor_1f_mr);
            return 1;
        case vi_left:
            EnterDoor(kitchen, kitchen_corridor);
            return 1;
        case vi_right:
            EnterDoor(laundry, laundry_corridor);
            return 1;
        default:
            break;
        }
        break;
    case ni_corridor:
        switch (vid){
        case vi_look:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
        }
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
        }
        break;
    default:
		*exist = 0;
        break;
    }
    return 0;
}

