#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_corridor_1f_fr(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("廊下は前方で左に折れている。");
            message("背後と左側に扉%nw%nwが\\",
                    ni_back_door, ni_left_door);
            if (Is(hall_right_door_opened) &&
                Is(bathroom_door_opened))
            {
                message("あり、それぞれ玄関ホールと浴室に通じている。");
            }
            else if (Is(hall_right_door_opened)){
                message("あり、前者は玄関ホールに通じている。");
            }
            else if (Is(bathroom_door_opened)){
                message("あり、後者は玄関ホールに通じている。");
            }
            else {
                message("ある。");
            }
            return 1;
        case vi_forward:
            move_area(ai_corridor_1f_mr);
            return 1;
        case vi_backward:
            if (Not(hall_right_door_unlocked)){
                msg_door_unlocked_by_opening();
                Set(hall_right_door_unlocked);
            }
            EnterDoor(entrance_hall, hall_right);
            return 1;
        case vi_left:
            EnterDoor(bathroom, bathroom);
            return 1;
        case vi_exit:
            message("窓から外に出られそうだが・・・。");
            return 1;
        default:
            break;
        }
		break;
    case ni_corridor:
        switch (vid){
        case vi_look:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_wall:
        switch(vid){
        case vi_look:
			message("右側の壁には窓が並んでいる。");
			message("窓の横になにか書いてある。");
			return 1;
        case vi_examine:
			message("開いた窓の下に、壁の文字と同じ色の、"
                    "茶色く変色した染みがある。");
			return 1;
        case vi_read:
			message("「出るな」と書かれている。");
			return 1;
		default:
			break;
		}
		break;
    case ni_window:
        switch(vid){
        case vi_look:
			message("手前の窓は開いている。");
			return 1;
        case vi_examine:
			message("押し上げられた窓枠をよく見ると、"
                    "下側が刃物のように鋭く細工されている。");
			return 1;
        case vi_exit:
            die_exiting_window();
			return 1;
        case vi_open:
			message("もう開いている。");
			return 1;
        case vi_close:
			message("枠が錆びついているのか、固くて閉まらない。");
			return 1;
		default:
			break;
		}
		break;
    case ni_door:
		msg_which_door();
        return 1;
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
		}
		break;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
		}
        break;
    case ni_floor:
    case ni_ceiling:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

