#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_corridor_1f_mr(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("廊下は前方に続いている。");
            if (Is(storage_door_opened)){
                message("右側に物置に通じる扉がある");
            }
            else {
                message("右側に扉がある");
            }
            message("背後では廊下が左手に折れている。");
            return 1;
        case vi_forward:
            move_area(ai_corridor_1f_br);
            return 1;
        case vi_backward:
            move_area(ai_corridor_1f_fr);
            return 1;
        case vi_right:
            EnterDoor(storage, storage);
            return 1;
        default:
            break;
        }
        break;
    case ni_corridor:
        switch (vid){
        case vi_look:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
		}
        break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
        return 1;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

