#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_corridor_2f_c(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("廊下は左右に続いている。");
            message("正面と背後に扉%nw%nwが\\",
                    ni_front_door, ni_back_door);
            if (Is(boys_room_door_opened) &&
                Is(landing_door_opened))
            {
                message("あり、それぞれ子供部屋と階段踊り場に通じている。");
            }
            else if (Is(boys_room_door_opened)){
                message("あり、前者は子供部屋に通じている。");
            }
            else if (Is(landing_door_opened)){
                message("あり、後者は階段踊り場に通じている。");
            }
            else {
                message("ある。");
            }
            return 1;
        case vi_forward:
            EnterDoor(boys_room, boys_room);
            return 1;
        case vi_backward:
            EnterDoor(landing, landing);
            return 1;
        case vi_left:
            move_area(ai_corridor_2f_l);
            return 1;
        case vi_right:
            move_area(ai_corridor_2f_cr);
            return 1;
        default:
            break;
        }
        break;
    case ni_corridor:
        switch (vid){
        case vi_look:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
	case ni_door:
        msg_which_door();
        return 1;
    case ni_front_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_forward, ni_invalid);
		}
        break;
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
		}
        break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
		break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

