#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_corridor_2f_cr(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("廊下は前方および背後に続いている。");
            message("左右に扉%nw%nwが\\",
                    ni_left_door, ni_right_door);
            if (Is(ladys_room_door_opened) &&
                Is(study_corridor_door_opened))
            {
                message("あり、それぞれぞれ婦人部屋と書斎に通じている。");
            }
            else if (Is(ladys_room_door_opened)){
                message("あり、左側の扉は婦人部屋に通じている。");
            }
            else if (Is(study_corridor_door_opened)){
                message("あり、右側の扉は書斎に通じている。");
            }
            else {
                message("ある。");
            }


            return 1;
        case vi_forward:
            move_area(ai_corridor_2f_r);
            return 1;
        case vi_backward:
            move_area(ai_corridor_2f_c);
            return 1;
        case vi_left:
            EnterDoor(ladys_room, ladys_room);
            return 1;
        case vi_right:
            EnterDoor(study, study_corridor);
            return 1;
        default:
            break;
        }
        break;
    case ni_corridor:
        switch (vid){
        case vi_look:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
		}
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
		}
        break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
		break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

void post_corridor_2f_cr(int time_passed){
    /*
	if (!time_passed) return;

	if (Is(shadow_appeared) || Is(shadow_behind_door) || Is(shadow_in_room)){
        //        cancel_move();
        die_touching_shadow();
    }
    */
}
