#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_corridor_2f_l(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("正面と左右に扉%nw%nw%nwがある。",
                    ni_front_door, ni_left_door, ni_right_door);
            
            if (Is(music_room_door_opened)){
                message("正面の扉は音楽室に通じている。");
            }
            if (Is(guestroom_2f_door_opened) &&
                Is(girls_room_door_opened))
            {
                message("左右の扉は、それぞれぞれ客室と子供部屋に通じている。");
            }
            else if (Is(guestroom_2f_door_opened)){
                message("あり、左側の扉は客室に通じている。");
            }
            else if (Is(girls_room_door_opened)){
                message("あり、右側の扉は子供部屋に通じている。");
            }
            message("背後には長い廊下が伸びている。");
            return 1;
        case vi_forward:
            if (Is(music_room_door_unlocked)){
	            EnterDoor(music_room, music_room);
            }
            else {
                msg_door_locked();
            }
            return 1;
        case vi_backward:
            move_area(ai_corridor_2f_c);
            return 1;
        case vi_left:
            EnterDoor(guestroom_2f, guestroom_2f);
            return 1;
        case vi_right:
            EnterDoor(girls_room, girls_room);
            return 1;
        default:
            break;
        }
        break;
    case ni_corridor:
        switch (vid){
        case vi_look:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
		break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_front_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_forward, ni_invalid);
		}
        break;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
		}
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
		}
        break;
    default:
		*exist = 0;
        break;
    }
    return 0;
}

