#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_corridor_2f_r(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("背後から続く廊下は、前方で行き止まりになっている。");
            message("左右に扉%nw%nwが\\",
                    ni_left_door, ni_right_door);
            if (Is(bedroom_door_opened) &&
                Is(library_corridor_door_opened))
            {
                message("あり、それぞれぞれ寝室と図書室に通じている。");
            }
            else if (Is(bedroom_door_opened)){
                message("あり、左側の扉は寝室に通じている。");
            }
            else if (Is(library_corridor_door_opened)){
                message("あり、右側の扉は図書室に通じている。");
            }
            else {
                message("ある。");
            }
            return 1;
        case vi_backward:
            move_area(ai_corridor_2f_cr);
            return 1;
        case vi_left:
            EnterDoor(bedroom, bedroom);
            return 1;
        case vi_right:
            EnterDoor(library, library_corridor);
            return 1;
        default:
            break;
        }
        break;
    case ni_corridor:
        switch (vid){
        case vi_look:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
		}
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
		}
        break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
		break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

