#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_entrance_hall(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("背後には玄関の扉%nwが、"
                    "正面と左右にもそれぞれ扉%nw%nw%nwがある。",
                    ni_back_door, ni_front_door, ni_left_door, ni_right_door);
            if (Is(hall_dining_door_opened)){
                message("正面の扉の向こうには食堂がある。");
            }
            if (Is(hall_right_door_opened) &&
                Is(hall_left_door_opened))
            {
                message("左右の扉の向こうには廊下が続いている。");
            }
            else if (Is(hall_left_door_opened)){
                message("左の扉の向こうには廊下が続いている。");
            }
            else if (Is(hall_right_door_opened)){
                message("右の扉の向こうには廊下が続いている。");
            }
            message("階段が二階へと続いている。");
            return 1;
        case vi_backward:
            message("玄関の扉は固く閉ざされている。");
            return 1;
        case vi_forward:
            if (Is(hall_dining_door_unlocked)){
                EnterDoor(dining, hall_dining);
            }
            else {
                msg_door_locked();
            }
            return 1;
        case vi_right:
            if (Is(hall_right_door_unlocked)){
                EnterDoor(corridor_1f_fr, hall_right);
            }
            else {
                msg_door_locked();
            }
            return 1;
        case vi_left:
            EnterDoor(corridor_1f_fl, hall_left);
            return 1;
        case vi_up:
            move_area(ai_landing);
            return 1;
        default:
            break;
        }
        break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_front_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_forward, ni_invalid);
        }
        break;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
        }
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
        }
        break;
    case ni_back_door:
        switch(vid){
        case vi_look:
            message("分厚い扉だ。壊すのは無理だろう。");
            return 1;
        case vi_examine:
            message("鍵はかかっていないのに開かない。");
            return 1;
        case vi_open:
        case vi_push:
        case vi_pull:
        case vi_close:
        case vi_hit:
        case vi_kick:
        case vi_destroy:
        case vi_touch:
            message("玄関の扉は固く閉ざされている。");
            return 1;
        default:
            break;
        }
    case ni_stairs:
        if (vid == vi_up || vid == vi_use){
            RedoArea(vi_up, ni_invalid);
        }
        break;
    case ni_brass_key:
		// 館内にいるなら真鍮の鍵は必ず持っているのでチェックは省略
		switch(vid){
        case vi_use:
            message("玄関の扉の鍵はすでに開いている");
            return 1;
        default:
            break;
        }
    default:
	    *exist = 0;
        break;
    }
    return 0;
}

