#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_garden(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch (vid){
        case vi_look:
            DescribeArea;
            message("中央には%nlが停まっている。",
                    ni_car);
            return 1;
        case vi_left:
            move_area(ai_entrance);
            return 1;
        case vi_right:
            move_area(ai_under_tree);
            return 1;
        default:
            break;
        }
        break;
    case ni_car:
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            message("荷台にはぎっしりと%nlが積まれている。",
                    ni_drum);
            return 1;
        case vi_examine:
            message("まだ新しい車だ。"
                    "あまり汚れていないところを見ると、"
                    "それほど長く放置されてはいない。"
                    "大佐の車だろうか。");
            return 1;
        case vi_enter:
        case vi_use:
            message("キーがない。");
            return 1;
        default:
            break;
        }
        break;
    case ni_drum:
        switch (vid){
        case vi_look:
            message("荷台いっぱいに並んでいる。",
                    ni_drum);
            return 1;
        case vi_examine:
            message("かすかな臭いからすると、中身はガソリンのようだ。");
            return 1;
        case vi_remove:
        case vi_move:
        case vi_get:
            msg_too_heavy();
            return 1;
        case vi_hit:
        case vi_kick:
        case vi_destroy:
            message("危険だからやめておこう。");
            return 1;
        case vi_open:
        case vi_close:
            message("缶の口は堅く閉まっている。");
            return 1;
        case vi_drink:
            message("飲用に適するとは思えないが、"
                    "どのみち口が堅く閉まっていて開けられない。");
            return 1;
        default:
            break;
        }
        break;
    default:
    	*exist = 0;
        break;
    }
    return 0;
}
