#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_girls_room(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("右側には%nlが、左側には%nlと%nl、%nlがある。",
					ni_bed, ni_bookshelf, ni_desk, ni_chair);
            message("背後には廊下に続く扉がある。");
            return 1;
        case vi_backward:
		case vi_exit:
            EnterDoor(corridor_2f_l, girls_room);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
        }
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
			message("あなたは机を乗り越えた。");
            EnterDoor(music_room, music_room_right);
        }
			return 1;
    case ni_wall:
        switch(vid){
        case vi_look:
        case vi_examine:
			message("机の向こう側に扉%nwがあるようだ",
					ni_left_door);
			return 1;
		default:
			break;
		}
		break;
	case ni_desk:
        switch(vid){
        case vi_look:
        case vi_examine:
			message("机の向こう側の壁に何かがある。");
			return 1;
		default:
			break;
		}
		break;
	case ni_bed:
        switch(vid){
        case vi_look:
			message("子供部屋らしくない、アンティークの豪華なベッドだ。");
			return 1;
		default:
			break;
		}
		break;
	case ni_bookshelf:
        switch(vid){
        case vi_look:
			message("児童書がずらりと並んでいる。");
			message("「ナルニア国物語」、"
					"「アーサー・ランサム全集」、"
					"「赤毛のアン」シリーズ、"
					"「ドリトル先生」シリーズ…"
					"部屋の主はかなり本好きの子供のようだ。");
            if (Not(girl_doll_taken)){
                message("本棚の上には%nlが乗っている。",
                        ni_girl_doll);
            }
			return 1;
        case vi_examine:
			if (Not(score_taken)){
				message("児童書ばかりだと思ったが、"
						"よく見ると%nlがある。",
						ni_score);
				Set(score_found);
			}
			else {
				message("あとは児童書しかないようだ。");
			}
			return 1;
		default:
			break;
		}
		break;
    case ni_girl_doll:
		ReturnIfHasItem;
        if (Is(girl_doll_taken)){
			ReturnNotExist;
		}
        switch (vid){
		case vi_get:
			command_get_item(nid, fi_girl_doll_taken);
			return 1;
		default:
			break;
        }
        break;
	case ni_score:
		ReturnIfHasItem;
        if (Not(score_found) || Is(score_taken)){
			ReturnNotExist;
		}
        switch (vid){
		case vi_get:
			command_get_item(nid, fi_score_taken);
			return 1;
		default:
			break;
		}
		break;
	case ni_chair:
    case ni_floor:
    case ni_ceiling:
	case ni_window:
	case ni_book:
		break;
    default:
		*exist = 0;
        break;
    }
    return 0;
}

