#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_guestroom_1f(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("左右の壁際にはそれぞれ%nlと%nlがある。"
                    "部屋の中央には%nlと%nlがある。",
					ni_cabinet, ni_bed, ni_table, ni_chair);
            //			message("この部屋には一人用の%nlと%nl、%nlがある。",
            //					ni_bed, ni_chair, ni_cabinet);
            message("背後には廊下に続く扉がある。");
//            if (Is(dragon_guestroom_1f) && Not(dragon_shotdown)){
            if (Is(dragon_in_guestroom_1f)){
                message("天井近くに、%nlが浮いている。",
                        ni_toy_dragon);
            }
            return 1;
        case vi_backward:
		case vi_exit:
            EnterDoor(corridor_1f_fl, guestroom_1f);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
        }
        break;
	case ni_cabinet:
		switch (vid){
		case vi_look:
            if (Is(guestroom_1f_cabinet_opened)){
                message("中は空だ。");
                return 1;
            }
            break;
		case vi_open:
            if (Is(guestroom_1f_table_moved)){
                message("%nnが邪魔だ。", ni_table);
                return 1;
            }
            if (Not(guestroom_1f_cabinet_opened)){
                message("%nnを開けた。", ni_cabinet);
                Set(guestroom_1f_cabinet_opened);
            }
            else {
                message("%nnはもう開いている。", ni_cabinet);
            }
            return 1;
		case vi_close:
            if (Is(guestroom_1f_table_moved)){
                message("%nnが邪魔だ。", ni_table);
                return 1;
            }
            if (Is(guestroom_1f_cabinet_opened)){
                message("%nnを閉めた。", ni_cabinet);
                Reset(guestroom_1f_cabinet_opened);
            }
            else {
                message("%nnは閉じている。", ni_cabinet);
            }
            return 1;
        case vi_up:
            if (Is(dragon_in_guestroom_1f)){
                message_dragon_too_high(nid);
                return 1;
            }
            break;
        default:
            break;
        }
        break;
    case ni_toy_dragon:
//        if (Not(dragon_guestroom_1f) || Is(dragon_shotdown)) ReturnNotExist;
//        if (Not(dragon_guestroom_1f)) ReturnNotExist;
        if (Not(dragon_in_guestroom_1f) && Not(dragon_shotdown)) ReturnNotExist;
        if (Is(dragon_taken)) ReturnNotExist;
        switch(vid){
        case vi_look:
            if (Not(dragon_shotdown)){
                message("ぱたぱたと翼を動かして浮かんでいる。"
                        "足には%nlを掴んでいる。",
                        ni_golden_key);
            }
            else {
                message("床の上に転がっている。");
            }
            return 1;
        case vi_examine:
            if (Not(dragon_shotdown)){
                message("どう見てもただの玩具だが、"
                        "なぜか空を飛んでいる。");
            }
            else {
                message("もうぴくりとも動かない。");
            }
            return 1;
        case vi_get:
            if (Not(dragon_shotdown)){
                message("ぱたぱたと翼を動かし、手の届かない高さに浮いている。");
            }
            else {
                command_get_item(nid, fi_dragon_taken);
            }
            return 1;
        case vi_hit:
        case vi_destroy:
            if (Not(dragon_shotdown)){
                message("素手で攻撃しようとしても届かない。");
            }
            else {
                message("追い討ちをかける必要はなさそうだ。");
            }
            return 1;
		case vi_shoot:
			RedoArea(vi_use, ni_slingshot);
        default:
            break;
        }        
        break;
    case ni_golden_key:
//        if (Not(dragon_guestroom_1f) || Not(dragon_shotdown)) ReturnNotExist;
//        if (Not(dragon_guestroom_1f)) ReturnNotExist;
        if (Not(dragon_in_guestroom_1f) && Not(dragon_shotdown)) ReturnNotExist;
        if (Is(golden_key_taken)) ReturnNotExist;
        switch(vid){
        case vi_look:
            if (Not(dragon_shotdown)){
                message("%nnの足に掴まれて宙に浮いている。",
                        ni_toy_dragon);
            }
            else {
                message("床の上に転がっている。");
            }
            return 1;
        case vi_get:
            if (Not(dragon_shotdown)){
                message("手の届かない高さに浮いている。");
            }
            else {
                command_get_item(nid, fi_golden_key_taken);
            }
            return 1;
        case vi_hit:
        case vi_destroy:
            if (Not(dragon_shotdown)){
                message("素手でたたき落とすのは無理そうだ。");
            }
            else {
                message("追い討ちをかける必要はなさそうだ。");
            }
            return 1;
        default:
            break;
        }        
        break;
    case ni_slingshot:
        if (!has_item(nid)) ReturnNotExist;
        switch(vid){
        case vi_use:
            if (Is(dragon_shotdown)){
                message("もう撃ち落とすものはない。");
	            return 1;
            }
            else if (Is(dragon_in_guestroom_1f)){
                if (Is(slingshot_repaired) && Has(marble)){
                    message("%nnで%nnを撃つと見事に%nnに命中した。",
                            ni_slingshot,
                            ni_marble,
                            ni_toy_dragon
                            );
	                proceed_flag_sequence(fs_dragon);
		            lose_item(ni_marble);
		            lose_item(ni_slingshot);
		            return 1;
                }
            }
			break;
        default:
            break;
        }
        break;
	case ni_table:
        switch (vid){
        case vi_move:
            if (Not(guestroom_1f_table_moved)){
                message("%nnを手前に動かした。",
                        ni_table);
                Set(guestroom_1f_table_moved);
            }
            else {
                message("%nnを元の場所に戻した。",
                        ni_table);
                Reset(guestroom_1f_table_moved);
            }
            return 1;
        case vi_up:
            if (Is(dragon_in_guestroom_1f)){
                message_dragon_too_high(nid);
                return 1;
            }
            break;
	    default:
		    break;
        }
        break;
	case ni_chair:
        switch (vid){
        case vi_move:
            if (Not(guestroom_1f_chair_moved)){
                message("%nnを手前に動かした。",
                        ni_chair);
                Set(guestroom_1f_chair_moved);
            }
            else {
                message("%nnを元の場所に戻した。",
                        ni_chair);
                Reset(guestroom_1f_chair_moved);
            }
            return 1;
        case vi_up:
            if (Is(dragon_in_guestroom_1f)){
                message_dragon_too_high(nid);
                return 1;
            }
            break;
	    default:
		    break;
        }
        break;
    case ni_floor:
        if (Is(dragon_shotdown)){
            if (Not(dragon_taken) && Not(golden_key_taken)){
                message("%nlと%nlが落ちている。", ni_toy_dragon, ni_golden_key);
            }
            else if (Not(dragon_taken)){
                message("%nlが落ちている。", ni_toy_dragon);
            }
            else if (Not(golden_key_taken)){
                message("%nlが落ちている。", ni_golden_key);
            }
            else {
                msg_nothing_any_more();
            }
        }
        else {
            msg_nothing_special();
        }
		break;
    case ni_ceiling:
	case ni_bed:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

