#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void guestroom_2f_upset_armor(void);
//void return_armor_in_guestroom(void);

int area_guestroom_2f(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;

    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            //            if (Is(armor_in_guestroom)){
            //                msg_armor_standing();
            //            }
			message("左右の壁際にはそれぞれ%nlと%nlがある。"
                    "部屋の中央には%nlと%nlがある。",
					ni_cabinet, ni_bed, ni_table, ni_chair);
            message("背後には廊下に続く扉がある。");
            return 1;
        case vi_backward:
        case vi_exit:
            EnterDoor(corridor_2f_l, guestroom_2f);
            //            return_armor_in_guestroom();
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
        }
        break;
    case ni_wall:
        switch (vid){
        case vi_look:
            if (Not(portrait_removed)){
                message("壁には%nlが掛かっている。",
                        ni_portrait);
            }
            else {
                message("絵がなくなったら、落ち着いた気がする。");
            }
			return 1;
        default:
            break;
        }
        break;
	case ni_cabinet:
		switch (vid){
		case vi_look:
            if (Is(guestroom_2f_cabinet_opened)){
                //                message("中に%nlが入っている", ni_note);
                message("中に%nlと%nlが入っている。", 
                        ni_bottle, ni_sponge);
                return 1;
            }
            break;
		case vi_open:
			guestroom_2f_upset_armor();
            if (Not(guestroom_2f_table_moved)){
                message("%nnが邪魔だ。", ni_table);
                return 1;
            }
            if (Not(guestroom_2f_cabinet_opened)){
                message("%nnを開けた。", ni_cabinet);
                Set(guestroom_2f_cabinet_opened);
            }
            else {
                message("%nnはもう開いている。", ni_cabinet);
            }
            return 1;
		case vi_close:
            if (Not(guestroom_2f_table_moved)){
                message("%nnが邪魔だ。", ni_table);
                return 1;
            }
            if (Is(guestroom_2f_cabinet_opened)){
                message("%nnを閉めた。", ni_cabinet);
                Reset(guestroom_2f_cabinet_opened);
            }
            else {
                message("%nnは閉じている。", ni_cabinet);
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_bottle:
        ReturnIfHasItem;
        if (Not(guestroom_2f_cabinet_opened)) ReturnNotExist;
        switch (vid){
        case vi_get:
            command_get_item(nid, fi_bottle_taken);
			guestroom_2f_upset_armor();
            return 1;
        default:
            break;
        }
        break;
    case ni_sponge:
        ReturnIfHasItem;
        if (Not(guestroom_2f_cabinet_opened)) ReturnNotExist;
        switch (vid){
        case vi_get:
            command_get_item(nid, fi_sponge_taken);
			guestroom_2f_upset_armor();
            return 1;
        default:
            break;
        }
        break;
        /*
    case ni_note:
        ReturnIfHasItem;
        if (Not(guestroom_2f_cabinet_opened)) ReturnNotExist;
        switch (vid){
        case vi_get:
            command_get_item(nid, fi_memo_taken);
			guestroom_2f_upset_armor();
            return 1;
        default:
            break;
        }
        break;
        */
	case ni_portrait:
		switch (vid){
		case vi_look:
			message("気のせいか、じっと見つめられているように感じる。");
			return 1;
		case vi_examine:
			message("古い油絵だ。フックで壁に掛けてある。");
			return 1;
		case vi_move:
			message("掛けてあるだけなので、簡単に外せそうだ");
			return 1;
		case vi_remove:
		case vi_turn:
            Set(portrait_has_removed);
            TestAndSet(portrait_removed,
                       "肖像画を壁から外して裏返しに置いた。",
                       "肖像画はもう外してある。");
			return 1;
		case vi_get:
			msg_too_large();
			return 1;
		case vi_put:
            TestAndReset(portrait_removed,
                         "肖像画をまた壁に掛けた。",
                         "肖像画は壁に掛かっている。");
            return 1;
	    default:
		    break;
		}
		break;
    case ni_table:
        switch (vid){
        case vi_look:
        case vi_examine:
            message("テーブルの上には%nlが数冊積まれている。", ni_book);
            return 1;
        case vi_move:
            if (Not(guestroom_2f_table_moved)){
                if (Not(guestroom_2f_book_moved)){
                    message("上に乗っている%nnが邪魔だ。", ni_book);
                    return 1;
                }
                if (Not(guestroom_2f_chair_moved)){
                    message("%nnが邪魔だ。", ni_chair);
                    return 1;
                }
                message("%nnを部屋の奥に動かした。",
                        ni_table);
                Set(guestroom_2f_table_moved);
				guestroom_2f_upset_armor();
            }
            else {
                // 戻す場合も、椅子が手前にあると邪魔
                if (Not(guestroom_2f_chair_moved)){
                    message("%nnが邪魔だ。", ni_chair);
                    return 1;
                }
                message("%nnを元の場所に戻した。",
                        ni_table);
                Reset(guestroom_2f_table_moved);
            }
            return 1;
	    default:
		    break;
        }
        break;
	case ni_chair:
        switch (vid){
        case vi_move:
            if (Not(guestroom_2f_chair_moved)){
                message("%nnを部屋の奥に動かした。",
                        ni_chair);
                Set(guestroom_2f_chair_moved);
				guestroom_2f_upset_armor();
            }
            else {
                message("%nnを元の場所に戻した。",
                        ni_chair);
                Reset(guestroom_2f_chair_moved);
            }
            return 1;
	    default:
		    break;
        }
        break;
	case ni_book:
        switch (vid){
        case vi_look:
            message("医学書が何冊か積んである。");
            return 1;
        case vi_examine:
            message("よく見ると一冊は%nlのようだ。", ni_logbook);
            Set(logbook_found);
            return 1;
        case vi_read:
            message("専門書のようだ。さっぱり理解できない。");
            return 1;
        case vi_get:
            message("持って行っても、役に立ちそうにない。");
            return 1;
        case vi_remove:
        case vi_move:
            if (Not(guestroom_2f_book_moved)){
                message("%nnを%nnの上にどけた。",
                        ni_book, ni_cabinet);
                Set(guestroom_2f_book_moved);
				guestroom_2f_upset_armor();
            }
            else {
                // テーブルの位置によって戻した後のグラフィックを2種類用意するのが
                // 面倒なので、戻せないようにする
                message("%nnはもうどけてある。",
                        ni_book);
                /*
                message("%nnを%nnの上に戻した。",
                        ni_book, ni_table);
                Reset(guestroom_2f_book_moved);
                */
            }
            return 1;
	    default:
		    break;
        }
        break;
    case ni_logbook:
        ReturnIfHasItem;
        //        if (Not(logbook_found) || Is(logbook_taken)){
        if (Not(logbook_found)){
			ReturnNotExist;
		}
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            return 1;
        case vi_examine:
            message("看護記録のようだ。");
            guestroom_2f_upset_armor();
            return 1;
        case vi_get:
            //            command_get_item(nid, fi_logbook_taken);
            //			guestroom_2f_upset_armor();
            msg_no_need_to_carry();
            return 1;
        case vi_read:
            msg_read_logbook();
            Set(logbook_read);
            guestroom_2f_upset_armor();
            return 1;
        default:
            break;
        }
        break;
    case ni_armor:
        if (Not(armor_in_guestroom)) ReturnNotExist;
        switch (vid){
        case vi_look:
        case vi_examine:
            msg_look_standing_armor();
            return 1;
        default:
            break;
        }
        break;
    case ni_sword:
        if (Not(armor_in_guestroom)) ReturnNotExist;
        switch (vid){
        case vi_look:
            msg_look_standing_armor_sword();
            return 1;
        case vi_examine:
        case vi_touch:
        case vi_get:
            return 1;
        default:
            break;
        }
        break;
    case ni_floor:
    case ni_ceiling:
    case ni_window:
	case ni_bed:
		break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

void guestroom_2f_upset_armor(void){
	if (Not(portrait_removed) && Not(portrait_eyes_right) &&
		Not(armor_dead) && NotActive(armor_to_guestroom))
        //		Not(armor_dead) && Not(start_armor_to_guestroom))
	{
        // メッセージはコマンドへのメッセージの後で出したいので、フラグセットのみ
        start_flag_sequence(fs_armor_to_guestroom);
        if (IsActive(armor_from_guestroom)){
            // 鎧が戻る途中なら、書斎を出るフェーズを飛ばす
            if (Is(armor_moving_from_guestroom)){
                printf("armor moving to study!!!!\n");
                jump_flag_sequence(fs_armor_to_guestroom, 
                                   //                                   fi_armor_moving_to_guestroom);
                                   fi_armor_in_guestroom);
            }
            clear_flag_sequence(fs_armor_from_guestroom);
        }
	}
}


void post_guestroom_2f(int time_passed){
    if (!time_passed) return;

    // 肖像画の目を動かす
    Toggle(portrait_eyes_right);
    /* 
   // 鎧イベント
    if (Is(armor_in_guestroom) && Staying(guestroom_2f)){
        die_killed_by_armor();
    }
    */
}


    /*
void return_armor_in_guestroom(void){
    clear_flag_sequence(fs_armor_to_guestroom);
    start_flag_sequence(fs_armor_from_guestroom);
    // 部屋を出ると、鎧は部屋を復元して去る
    if (Is(armor_to_guestroom) || Is(armor_in_guestroom)){
        Reset(guestroom_2f_chair_moved);
        Reset(guestroom_2f_book_moved);
        Reset(guestroom_2f_table_moved);
        Reset(guestroom_2f_cabinet_opened);
        Reset(start_armor_to_guestroom);
        Reset(armor_to_guestroom);
        Reset(armor_in_guestroom);
    }
}
*/
