#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_ladys_room(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("部屋の中には%nlと%nlがある",
					ni_wardrobe, ni_dressing_table);
            message("背後には廊下に続く扉がある。");
            return 1;
        case vi_backward:
        case vi_exit:
            EnterDoor(corridor_2f_cr, ladys_room);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
        }
    case ni_floor:
        switch(vid){
        case vi_look:
			if (Not(branch_taken)){
				message("%nlが落ちている。",
						ni_branch);
				return 1;
			}
			else {
				break;
			}
        default:
            break;
        }
        break;
    case ni_window:
        switch(vid){
        case vi_look:
			message("窓ガラスの一部が割れて、木の枝が侵入している。");
			return 1;
        default:
            break;
        }
        break;
	case ni_branch:
        switch(vid){
        case vi_get:
			if (!has_item(ni_branch)){
				command_get_item(ni_branch, fi_branch_taken);
			}
			return 1;
        default:
            break;
        }
        break;
	case ni_dressing_table:
        switch(vid){
        case vi_examine:
			message("小さな%nlが付いている。",
					ni_drawer);
			return 1;
        default:
            break;
        }
        break;
	case ni_drawer:
        switch(vid){
		case vi_look:
			if (Is(dressing_table_opened)){
				if (Not(necklace_taken)){
					message("抽斗の中には%nlが入っている。", ni_necklace);
				}
				else {
					message("抽斗の中は空だ。");
				}
				return 1;
			}
			break;
        case vi_open:
        case vi_pull:
            if (Is(dressing_table_unlocked)){
                TestAndSet(dressing_table_opened,
                           "化粧台の抽斗を開けた。",
                           "化粧台の抽斗はもう開いている。");
            }
            else {
                message("鍵が掛かっている。");
            }
            return 1;
        case vi_close:
        case vi_push:
			TestAndReset(dressing_table_opened,
                         "化粧台の抽斗を閉じた。",
                         "化粧台の抽斗は閉じている。");
			return 1;
        default:
            break;
        }
        break;
    case ni_golden_key:
        if (has_item(nid)){
            switch(vid){
            case vi_use:
				if (Not(dressing_table_unlocked)){
					Set(dressing_table_unlocked);
					lose_item(nid);
                    message("鍵が開いた。");
				}
				else {
					message("もう鍵は掛かっていない。");
				}
                return 1;
            default:
                break;
            }
            return 0;
        }
		else {
            ReturnNotExist;
		}
        break;
	case ni_necklace:
		if (has_item(nid)){
			*exist = 0;
			return 0;
		}
		if (Is(dressing_table_opened)){
	        switch(vid){
			case vi_get:
                command_get_item(nid, fi_necklace_taken);
                //				Set(start_shadow);
                start_flag_sequence(fs_shadow);
				Set(save_forbidden);
				return 1;
	        default:
	            break;
	        }
		}
		else { // 抽斗が開いていない
			*exist = 0;
		}
		break;
	case ni_wardrobe:
        switch (vid){
        case vi_open:
			TestAndSet(wardrobe_opened,
                       "洋服箪笥の扉を開けた。",
                       "洋服箪笥の扉はもう開いている。");
			return 1;
        case vi_close:
			TestAndReset(wardrobe_opened,
                         "洋服箪笥の扉を閉じた。",
                         "洋服箪笥の扉は閉じている。");
			return 1;
        case vi_enter:
			if (Is(wardrobe_opened)){
				message("洋服箪笥の中に入った。");
                move_area(ai_wardrobe);
			}
			else {
				message("扉が閉まっている。");
			}
			return 1;
        default:
            break;
        }
        break;
    case ni_wall:
    case ni_ceiling:
 		break;
	default:
		*exist = 0;
        break;
    }
    return 0;
}

    /*
void post_ladys_room(int time_passed){
	if (!time_passed) return;
    if (Is(start_shadow)){
        msg_shadow_appeared();
        Reset(start_shadow);
        Set(shadow_appeared);
    }
	else if (Is(shadow_appeared)){
		msg_shadow_behind_door();
        Reset(shadow_appeared);
        Set(shadow_behind_door);
	}
	else if (Is(shadow_behind_door)){
		msg_shadow_in_room();
        Reset(shadow_behind_door);
        Set(shadow_in_room);
	}
	else if (Is(shadow_in_room)){
        die_touching_shadow();
	}
}
    */
