#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void describe_plane(void);
void upset_armor_in_library(void);
//void return_armor_in_library(void);


int area_library(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            if (Is(armor_in_library)){
                msg_armor_standing();
            }
            message("正面と左右に%nn%nw%nw%nwが並んでいる。",
                    ni_bookshelf, ni_front_bookshelf,
                    ni_left_bookshelf, ni_right_bookshelf);
			message("正面と右側に扉%nw%nwがある。",
					ni_front_door, ni_right_door);
			message("正面の扉は書斎に\\");
			if (Is(library_corridor_door_opened)){
				message("、右側の扉は廊下に続いている。");
			}
			else {
				message("続いている。");
			}
            if (Is(bookshelf_moved)){
                msg_secret_passage();
            }
			return 1;
        case vi_forward:
			if (Not(study_library_door_closed)){
                //                return_armor_in_library();
		        move_area(ai_study);
			}
			else {
				msg_door_closed();
			}
            return 1;
		case vi_right:
		case vi_exit:
            //            return_armor_in_library();
            EnterDoor(corridor_2f_r, library_corridor);
            //            move_dragon_in_corridor_2f();
            return 1;
        case vi_up:
            if (Is(library_ladder_set)){
                RedoArea(vi_up, ni_ladder);
            }
            break;
        default:
            break;
        }
        break;
    case ni_golden_key:
        if (IsActive(dragon) || Complete(dragon)) ReturnNotExist;
        switch (vid){
        case vi_get:
            message("手を伸ばすと、"
                    "背後からなにか飛び込んできて%nnをさらった。"
                    "その小さな鳥のようなものは、"
                    "そのまま扉の隙間から部屋の外へと飛び去った。",
                    ni_golden_key);
            start_flag_sequence(fs_dragon);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_front_door:
        switch (vid){
        case vi_look:
            message("扉の向こうは書斎だ。");
            return 1;
        case vi_open:
        case vi_push:
            TestAndReset(study_library_door_closed,
                         "書斎への扉を開けた。",
                         "書斎への扉はもう開いている。");
            return 1;
        case vi_close:
        case vi_pull:
            TestAndSet(study_library_door_closed,
                       "書斎への扉を閉めた。",
                       "書斎への扉はもう閉まっている。");
            return 1;
		case vi_enter:
            RedoArea(vi_forward, ni_invalid);
        default:
            break;
        }
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
		}
        break;
    case ni_bookshelf:
        msg_which_bookshelf();
        return 1;
    case ni_front_bookshelf:
        switch (vid){
        case vi_look:
            message("大きな本棚に、"
                    "高価そうな専門書が並んでいる。");
            return 1;
        case vi_examine:
            message("本棚には、とくに変わったところはないようだ。");
            message("本はほとんど経済書だが、端の方に医学書も並んでいる。"
                    "古い本ばかりだが、大富豪のコレクションだろうか。");
            return 1;
        case vi_up:
            msg_cannot_climb();
            return 1;
        case vi_move:
        case vi_push:
        case vi_pull:
            msg_cannot_move();
            return 1;
        default:
            break;
        }
        break;
    case ni_left_bookshelf:
        switch (vid){
        case vi_look:
            message("大きな本棚に、"
                    "古典から現代文学まで文芸作品が並んでいる。");
            describe_plane();
            return 1;
        case vi_examine:
            message("本棚には、とくに変わったところはないようだ。");
            message("値の張りそうな立派な書籍ばかりだが、"
                    "戦後の作品はないようだ。大富豪のコレクションだろうか。");
            describe_plane();
            return 1;
        case vi_up:
            if (Is(library_ladder_set)){
                RedoArea(vi_up, ni_ladder);
            }
            else {
                msg_cannot_climb();
            }
            return 1;
        case vi_move:
        case vi_push:
        case vi_pull:
            msg_cannot_move();
            return 1;
        default:
            break;
        }
        break;
    case ni_right_bookshelf:
        switch (vid){
        case vi_look:
            message("小さな本棚に、"
                    "落ち着いた雰囲気の図書室に似合わぬ"
                    "怪しげなオカルト本が並んでいる。");
            return 1;
        case vi_examine:
            upset_armor_in_library();
            message("黒魔術や悪魔崇拝といった、"
                    "理解しがたい世界を扱った本が並んでいる。"
                    "この棚の本で、あなたに読めそうなのは%nlぐらいだ。",
                    ni_easy_necromancy);
            if (Is(bookshelf_moved)){
                msg_secret_passage();
            }
            else if (Is(bookshelf_book_removed)){
                message("本棚の奥に、%nlがある。", ni_handle);
            }
            else {
                message("本の隙間から、奥に何かが見える。");
            }
            return 1;
        case vi_up:
            upset_armor_in_library();
            msg_cannot_climb();
            return 1;
        case vi_move:
        case vi_push:
        case vi_pull:
            upset_armor_in_library();
            if (Is(bookshelf_unlocked)){
                if (Not(bookshelf_moved)){
                    message("本棚を動かすと隠された%nlが現れた。",
                            ni_passage);
                    Set(bookshelf_moved);
                }
                else {
                    message("本棚はもう動かしてある。");
                }
            }
            else {
                msg_cannot_move();
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_book:
        switch (vid){
        case vi_look:
            message("本はうんざりするほどたくさんある。");
            return 1;
        case vi_examine:
            message("もう少し本棚ごとに調べてみるか。");
            return 1;
        case vi_get:
        case vi_remove:
        case vi_move:
            upset_armor_in_library();
//            message("本棚の本をどけると、小さな鍵穴が出てきた。");
            message("本棚の本をどけると、小さな%nlが現れた。", ni_handle);
            Set(bookshelf_book_removed);
            return 1;
        default:
            break;
        }
        break;
	case ni_handle:
	    if (Not(bookshelf_book_removed)) ReturnNotExist;
		switch (vid){
        case vi_look:
            if (Is(bookshelf_unlocked)){
                message("%nnは下がっている。", ni_handle);
            }
            else {
                message("%nnは上がっている。", ni_handle);
            }
            return 1;
        case vi_examine:
            message("くぼみに沿って上下に動くようだ。");
            return 1;
        case vi_move:
        case vi_push:
        case vi_pull:
            upset_armor_in_library();
            message("力を込めて%nnを押し下げると、"
                    "がたんと本棚の裏で何かが外れるような音がした。", ni_handle);
            Set(bookshelf_unlocked);
            return 1;
        default:
            break;
		}
		break;
		/*
	case ni_silver_key:
        if (has_item(nid)){
            switch (vid){
            case vi_use:
                if (Is(bookshelf_book_removed) && Not(bookshelf_unlocked)){
                    message("本棚の奥の鍵穴に差し込んで回すと、"
                            "がたんと何かが外れる音がした。");
                    Set(bookshelf_unlocked);
                    lose_item(ni_silver_key);
                    return 1;
                }
                else {
                    break;
                }
            default:
                break;
            }
        }
        else {
            ReturnNotExist;
        }
*/
    case ni_easy_necromancy:
        //        ReturnIfHasItem;
        upset_armor_in_library();
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            return 1;
        case vi_examine:
            message("一般向けのオカルト本の類のようだ。");
            return 1;
        case vi_read:
            msg_read_easy_necromancy();
            Set(easy_necromancy_read);
            return 1;
        case vi_get:
            msg_no_need_to_carry();
            //            command_get_item(ni_easy_necromancy, fi_easy_necromancy_taken);
            return 1;
        default:
            break;
        }
        break;
    case ni_ladder:
        if (has_item(nid)){
            switch (vid){
            case vi_use:
            case vi_put:
                message("あなたは本棚に梯子を掛けた。");
				Set(library_ladder_set);
                lose_item(nid);
                return 1;
            default:
                break;
            }
        }
		else {
			if (Not(library_ladder_set)){
				ReturnNotExist;
			}
            switch (vid){
            case vi_get:
                message("梯子を手に入れた。");
                get_item(nid);
                Reset(library_ladder_set);
                return 1;
            case vi_use:
            case vi_put:
                message("梯子はもう立てかけてある。");
                return 1;
            case vi_up:
                message("梯子を登った。");
                move_area(ai_bookshelf);
                return 1;
            default:
                break;
            }
		}
        break;
    case ni_passage:
        if (Not(bookshelf_moved)) ReturnNotExist;
        switch (vid){
        case vi_examine:
             if (has_light() || (Is(candle_put))){
//				 if ((Has(candle) && Is(candle_lit)) ||
//                (Has(lantern) && Is(lantern_lit)) ||
//				(Is(candle_put)))
                message("通路の奥に、小部屋があるようだ。");
            }
            else {
                msg_no_light();
            }
            return 1;
        case vi_enter:
			// どちらかの光源を持っているか、
			// 隠し部屋に灯のついた蝋燭を置いていたらOK
			// 後者をOKにしないと、ランタンをつけずに蝋燭を置いて出たら
			// ハマりになる
            if (has_light() || (Is(candle_put))){
                // 鎧を倒さず書斎の扉も閉めずに入ると、
                // 閉じこめられてゲームオーバーになるので、
                // 隠し部屋ではセーブを禁止する。
                Set(save_forbidden);
                move_area(ai_secret_room);
            }
            else {
                msg_no_light();
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_armor:
        if (Not(armor_dead) &&
            Not(armor_in_library) &&
            Not(armor_crushed) &&
            Is(study_library_door_closed))
        {
            ReturnNotExist;
        }
        if (Is(armor_in_library)){
            switch (vid){
            case vi_look:
            case vi_examine:
                msg_look_standing_armor();
                return 1;
            default:
                break;
            }
        }
        else if (Is(armor_dead)){
            switch (vid){
            case vi_look:
                message("床の上に横たわっている。"
                        "兜は横に転がり落ちている。");
                return 1;
            case vi_examine:
                message("ただの鎧だ。もう動くこともないだろう。");
                return 1;
            case vi_get:
                message("こんなものを着たら、歩くのも大変だ。");
                return 1;
            case vi_hit:
            case vi_kick:
            case vi_destroy:
                message("もう危険はない。放っておこう。");
                return 1;
            default:
                break;
            }
        }
        else if (Is(armor_crushed)){
            switch (vid){
            case vi_look:
                message("床の上に突っ伏して動かない。"
                        "兜は横に転がり落ちている。");
                return 1;
            case vi_examine:
                message("鎧の中は空っぽだ。"
                        "胴鎧の内側に%nlのようなものが描いてある。",
                        ni_magic_circle);
                return 1;
            case vi_hit:
            case vi_kick:
            case vi_destroy:
                message("鎧を破壊するのは難しそうだ。");
                return 1;
            default:
                break;
            }
        }
        else { // 書斎に座っている
            switch (vid){
            case vi_look:
                message("隣の書斎の奥に座っている。");
                return 1;
            case vi_examine:
            case vi_get:
            case vi_hit:
            case vi_kick:
            case vi_touch:
            case vi_destroy:
            case vi_move:
                msg_too_far();
                return 1;
            default:
                break;
            }
        }
        break;
    case ni_sword:
        if (Not(armor_dead) &&
            Not(armor_in_library) &&
            Is(study_library_door_closed))
        {
            ReturnNotExist;
        }
        if (Is(armor_dead)){
            switch (vid){
            case vi_look:
                message("鎧の側に落ちている。");
                return 1;
            case vi_examine:
                message("真剣だ。こんなもので切られたらひとたまりもない。");
                return 1;
            case vi_get:
                message("素人が振り回すには危険すぎる。");
                return 1;
            case vi_hit:
            case vi_kick:
            case vi_destroy:
                message("もう危険はない。放っておこう。");
                return 1;
            default:
                break;
            }
        }
        else if (Is(armor_crushed)){
            switch (vid){
            case vi_look:
                message("鎧が固く握りしめている。");
                return 1;
            case vi_examine:
            case vi_touch:
            case vi_get:
                return 1;
            default:
                break;
            }
        }
        else {
            switch (vid){
            case vi_look:
                msg_look_standing_armor_sword();
                return 1;
            case vi_examine:
            case vi_touch:
            case vi_get:
                return 1;
            default:
                break;
            }
        }
        break;
    case ni_magic_circle:
        if (Not(armor_crushed)) ReturnNotExist;
        switch (vid){
        case vi_look:
            if (Is(armor_dead)){
                msg_no_magic_circle();
            }
            else {
                message("同心円の内部に、"
                        "文字とも記号ともつかないものが書き連ねられている。");
            }
            return 1;
        case vi_examine:
            if (Is(armor_dead)){
                msg_no_magic_circle();
            }
            else {
                message("胴鎧の内側に、墨で描かれている。");
            }
            return 1;
        case vi_erase:
            if (Is(armor_dead)){
                msg_no_magic_circle();
            }
            else {
                if (has_item(ni_sponge)){
                    RedoArea(vi_use, ni_sponge);
                }
                else {
                    message("手でこすったぐらいでは消えそうにない。");
                }
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_sponge:
        if (!has_item(ni_sponge)) ReturnNotExist;
        switch (vid){
        case vi_use:
            if (Is(sponge_wet)){
                message("濡れたスポンジで鎧の内側をこすると、魔法陣は消えた。");
                message("もがいていた鎧の四肢が力を失い、がしゃっと床の上に崩れ落ちた。");
                //                Reset(start_armor_to_library);
                //                Reset(armor_crushed);
                //                Reset(armor_reviving);
                clear_flag_sequence(fs_armor_to_library);
                Set(armor_dead);
                lose_item(ni_fishing_rod);
                lose_item(ni_sponge);
            }
            else {
                message("乾いたスポンジで鎧の内側をこすってみたが、"
                        "魔法陣は消えない。"
                        "水で濡らさないと無理だろう。");
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_fossil:
        // 持っている場合
        if (has_item(nid)){
            switch (vid){
            case vi_put:
                message("%nnを本棚の影に置いた。",
                        nid);
                Set(fossil_set);
                lose_item(nid);
                return 1;
            default:
                break;
            }
        }
        // 設置済みの場合
        else if (Is(fossil_set)){
            switch (vid){
            case vi_get:
                message("もう必要ないだろう。");
                return 1;
            default:
                break;
            }
        }
        // まだ入手していない場合
        else {
            ReturnNotExist;
        }
        break;
    case ni_floor:
        switch (vid){
        case vi_look:
            if (NotActive(dragon)){
                message("床の上に%nlが落ちている",
                        ni_golden_key);
            }
            else {
                message("もう何も落ちていない。");
            }
            return 1;
        default:
            break;
        }        
        break;
    case ni_wall:
    case ni_ceiling:
        break;
    default:
	    *exist = 0;
        break;
    }
    return 0;
}

void describe_plane(void){
    if (Not(origami_plane_taken)){
        message("本棚の上に、なにか乗っているようだ。");
    }
}
void upset_armor_in_library(void){
    if (Not(armor_dead) && Not(study_library_door_closed) &&
        NotActive(armor_to_library))
    {
        printf("upset %d\n", fs_armor_to_library);
        start_flag_sequence(fs_armor_to_library);
        // メッセージはコマンドへのメッセージの後で出したいので、フラグセットのみ
        //        TestAndSet(start_armor_to_library,
        //                   NULL, NULL);
    }
}
/*
void return_armor_in_library(void){
	if (Is(armor_dead)) return;
    Reset(start_armor_to_library);
    Reset(armor_in_library);
    Reset(armor_crushed);
    Reset(armor_reviving);
    Reset(bookshelf_book_removed);
}
*/
/*
void move_dragon_in_corridor_2f(void){
    if (Is(dragon_corridor_2f_r)){
        message("廊下に出ると、何かちいさなものが階段の方へ飛び去った。"
                "それはそのまま階下へと姿を消した。");
        proceed_flag_sequence(fs_dragon);
    }
}
*/

void post_library(int time_passed){
    if (!time_passed) return;

    // 鎧イベント
    // start_armor_to_library=>crushed=>revive, 
    // start_armor_to_library=>armor_in_libraryであるので、
    // 各イベントペア毎に逆順に判定する
    /*
    if (Is(armor_reviving)){
    }
    else if (Is(armor_crushed)){
        Set(armor_reviving);
    }
    //    else if (Is(armor_in_library)){
    //        die_killed_by_armor();
    //    }
    else if (Is(start_armor_to_library)){
    }
    */
}
