#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_mailbox(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            //            message("%nlが%nlの玄関へと延び、その脇には%nlが立っている。",
            //                   ni_path, ni_house, ni_mailbox);
            message("目の前には%nlがある。"
                    "%nlが%nlの玄関へと延び、"
                    "その脇には一本の%nlが立っている。",
                    ni_mailbox, ni_path, ni_house, ni_tree);
            return 1;
        case vi_forward:
            move_area(ai_entrance);
            return 1;
        case vi_backward:
        case vi_left:
        case vi_right:
            message("ここまで来て帰るわけにはいかない。");
            return 1;
        default:
            break;
        }
        break;
    case ni_mailbox:
        switch(vid){
        case vi_look:
            message("さび付いた金属製の郵便受けだ。");
            if (Is(mailbox_opened)){
                if (has_item(ni_leaflet) && has_item(ni_medal)){
                    message("中は空だ。");
                }
                else if (has_item(ni_leaflet)){
                    message("中に%nlが入っている。", ni_medal);
                }
                else {
                    message("中に%nlが入っている。", ni_leaflet);
                }
            }
            return 1;
        case vi_open:
            if (Is(mailbox_opened)){
                message("郵便受けはすでに開いている。");
            }
            else {
                Set(mailbox_opened);
                message("郵便受けを開けた。\\");
                if (Not(leaflet_taken)){
                    message("なにか入っているようだ。");
                }
                else {
                    message("");
                }
            }
            return 1;
        case vi_close:
            if (Is(mailbox_opened)){
                Reset(mailbox_opened);
                Set(mailbox_has_closed);
                message("郵便受けを閉めた。");
            }
            else {
                message("郵便受けは閉まっている。");
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_tree:
        switch (vid){
        case vi_look:
            message("幹の途中で折れ、枯れてしまっている。");
            return 1;
        case vi_examine:
            message("落雷にでも遭ったのだろうか。幹の途中で折れている。");
            return 1;
        case vi_get:
        case vi_move:
        case vi_push:
        case vi_pull:
            message("しっかり根を張っており、とても動かせそうにない。");
            return 1;
        case vi_destroy:
        case vi_hit:
        case vi_kick:
            message("枯れ木とはいえ、素手で破壊するのは無理だ。");
            return 1;
        case vi_up:
            message("木登りをするほどの高さは残っていない。");
            return 1;
        default:
            break;
        }
        break;
    case ni_leaflet:
		if (has_item(ni_leaflet)){
			*exist = 0;
			return 0;
		}
        if (Is(mailbox_opened)){
            switch(vid){
            case vi_look:
                message(noun_description(nid));
                return 1;
            case vi_get:
                command_get_item(ni_leaflet, fi_leaflet_taken);
                return 1;
            default:
                break;
            }
        }
        else { // 郵便受けが閉まっている場合
			*exist = 0;
        }
        break;
    case ni_medal:
		if (has_item(ni_medal)){
			*exist = 0;
			return 0;
		}
        if (Is(mailbox_opened) && has_item(ni_leaflet)){
            switch(vid){
            case vi_look:
                message("小さなメダルだ。");
                return 1;
            case vi_get:
                command_get_item(ni_medal, fi_medal_taken);
                return 1;
            default:
                break;
            }
        }
        else { // 郵便受けが閉まっているか上に手紙が乗っている場合
			*exist = 0;
        }
        break;
    case ni_path:
		break;
    case ni_house:
        switch(vid){
		case vi_look:
			message("切妻駒形屋根の立派な家だ");
			return 1;
		case vi_examine:
			message("近づいてみないとよくわからないが、"
					"外見上は変わった様子は見られない。");
			return 1;
        default:
            break;
        }
        break;
    default:
    	*exist = 0;
        break;
    }
    return 0;
}
