#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_playroom(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("部屋の中央には%nlがある。",
                    ni_billiard_table);
            message("背後には廊下に続く扉がある。");
            return 1;
        case vi_backward:
		case vi_exit:
            EnterDoor(corridor_1f_bl, playroom);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
        }
        break;
    case ni_billiard_table:
        switch (vid){
        case vi_examine:
			if (Is(billiard_ball_lost)){
				message("穴の中に詰まった%nlに、玉が引っ掛かっているようだ。",
						ni_wastepaper);
				Set(essay_found);
				return 1;
			}
			// 玉を落とさなければなにも見つけられない
			break;
		default:
			break;
		}
        break;
	case ni_wastepaper:
		if (Not(essay_found) || Is(essay_taken)) ReturnNotExist;
        switch (vid){
        case vi_look:
        case vi_examine:
			message("%nwの穴の中に紙のようなものが詰まっている。",
						ni_billiard_ball);
			return 1;
		case vi_get:
			command_get_item(nid, fi_essay_taken);
			return 1;
		default:
			break;
		}
        break;
    case ni_darts_target:
        switch (vid){
        case vi_look:
        case vi_examine:
            //			if (Not(card_taken)){
            message("%nlがダーツで留められている。",
                    ni_note);
            return 1;
                //			}
        default:
            break;
        }
        break;
    case ni_note:
        //        ReturnIfHasItem;
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            return 1;
        case vi_examine:
            message("誰かに宛てたメッセージのようだ。");
            return 1;
        case vi_get:
            msg_no_need_to_carry();
			return 1;
        case vi_read:
            msg_read_sanders_note();
            return 1;
        default:
            break;
        }
        break;
    case ni_wall:
        switch (vid){
        case vi_look:
            message("奥の壁には%nlがある。\\",
                    ni_window);
            message("左側の壁には%nlが掛かっている。",
                    ni_darts_target);
            return 1;
        default:
            break;
        }
        break;
	case ni_billiard_ball:
        if (has_item(nid)){
            switch(vid){
            case vi_use:
            case vi_throw:
            case vi_put:
				message("あなたは%nnの上に%nnを転がした。",
						ni_billiard_table, ni_billiard_ball);
				message("玉はころころと転がると、ガタンと隅の穴に入った。");
				message("おや、穴に落ちた玉がそのまま出てこない。");
				lose_item(nid);
				Set(billiard_ball_lost);
                return 1;
            default:
                break;
            }
            return 0;
        }
    case ni_ceiling:
    case ni_floor:
	case ni_window:
		break;
	default:
		*exist = 0;
        break;
    }
    return 0;
}

