#include <stdio.h>
#include <string.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int command_callback_cast_spell(char *line);
void callback_invoke_projected_circle(void);
void callback_sendback_great_old_one(void);
void callback_remove_water(void);

int area_temple(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("ここは地下の空洞に作られた古い神殿のようだ。"
					"周囲の壁に沿って、"
					"非ユークリッド幾何学的な外見の柱が立ち並んでおり、"
//					"この地の先住民の遺跡とは似ても似つかぬ、"
					"病的な空間を形作っている。");
			message("向こう側の壁には、%nlの入り口らしきものが見えている。",
					ni_passage);
			if (Is(temple_unsunken)){
				message("背後は崩れてしまい、地下室へ戻る道は閉ざされている。");
				message("床の中央には、名状し難い存在%nwが根を下ろしている。",
						 ni_it);
			}
			else {
				message("背後には、地下室へと続く通路がある。");
				message("床は完全に水没しており、"
				       "中央には巨大ななにか%nwが浮かんでいる。",
					   ni_it);
			}
            return 1;
		case vi_forward:
			if (Not(temple_unsunken)){
				message("床は水没しており、そこまでたどり着けない。");
			}
			else if (Not(temple_burning)){
				message("触手が行く手を塞いでいる。");
			}
			else {
				message("あなたは斜面を滑り降りると、"
						"荒れ狂う炎と触手を掻い潜るようにして"
						"神殿を走り抜け、"
						"%nnへと飛び込んだ！",
						ni_passage);
				move_area(ai_cave);
			}
			return 1;
		case vi_backward:
		case vi_exit:
			if (Is(great_old_one_gone)){
				message("壁が崩れて、来た道を塞いでしまっている。");
			}
			else {
	            move_area(ai_corridor_0f);
			}
            return 1;
        case vi_cast:
            message("何と唱える?");
            set_command_callback(command_callback_cast_spell);
            set_term_prompt(QUERY_PROMPT);
            return 1;
        default:
            break;
        }
        break;
    case ni_spell:
        if (vid == vi_cast){
            RedoArea(vi_cast, ni_invalid);
        }
        break;
	case ni_lantern:
		if (!has_item(nid)) ReturnNotExist;
		switch (vid){
		case vi_throw:
			message("ランタンを思い切り遠くへ投げると、"
					"たちまちガソリンに引火し、燃え広がった。");
			message("肉塊は炎から逃れようと触手を持ち上げ、"
					"激しく悶え狂っている。");
			Set(temple_burning);
            lose_item(ni_lantern);
			return 1;
		default:
			break;
		}
		break;
	case ni_it:
		switch (vid){
		case vi_look:
		case vi_examine:
			message("巨大な肉塊には、"
					"冒涜的にも人の%nlのようなものが"
                    "幾つも浮かび上がり、"
					"上部からは悍ましい%nlが伸びている。",
					ni_face, ni_tentacle
					);
			if (Not(great_old_one_gone)){
				message("それはゆっくりと脈打ちながら蠢いている。");
			}
			else if (Not(temple_burning)){
				message("それは理性のない獣のように荒れ狂っている。");
			}
			else {
				message("それは炎に焼かれ、断末魔の狂おしい踊りを見せている。");
			}
			return 1;
		default:
			break;
		}
		break;
	case ni_face:
		switch (vid){
		case vi_look:
		case vi_examine:
			if (Not(great_old_one_gone)){
				message("どの顔も虚ろな表情をしているが、"
						"蟻の巣を観察する人間のような眼で、"
						"あなたを見つめている。");
			}
			else {
				message("絶叫するかのように大きく口を開けている。"
						"眼は大きく開かれているが、すでに理性の色はない。");
			}
			return 1;
		default:
			break;
		}
		break;
	case ni_tentacle:
		switch (vid){
		case vi_look:
		case vi_examine:
			if (Not(great_old_one_gone)){
				message("触手は何かを掴もうとするかのように、"
                        "天井の方へと伸ばされている。\\"
						);
			}
			else {
				message("激しく振り回されている。\\");
			}
            message("何本かは傷付いて途中で切断され、"
                    "忌まわしい体液が流れ出している。");
			return 1;
		default:
			break;
		}
		break;
	case ni_passage:
		switch (vid){
		case vi_look:
		case vi_examine:
			message("奥へと続いているようだが、"
					"ここからではよく見えない。");
			return 1;
		case vi_enter:
			RedoArea(vi_forward, ni_invalid);
			return 1;
		default:
			break;
		}
		break;
    case ni_floor:
		if (Not(great_old_one_gone)){
			message("床は完全に水没している。");
			return 1;
		}
		switch (vid){
		case vi_look:
		case vi_examine:
			message("水が引いた後には、石の床が見えている。");
			message("中央には%nlが根を下ろし、"
					"向こう側には壁の通路へと続く階段が見える。",
					ni_it);
			message("こちら側は急な斜面になっており、"
					"なんとか床まで降りられそうだ。");
			if (Is(temple_ceiling_destroyed)){
				message("%nnの周りには、ドラム缶から流れ出した"
						"ガソリンが広がっている。",
						ni_it);
			}
			return 1;
		default:
			break;
		}
        return 1;
    case ni_wall:
    case ni_ceiling:
		if (Is(magic_circle_invoked) && Is(cycrotron_activated)){
			message("空洞の天井部の岩肌には、魔法陣が浮かび上がっている。");
		}
		else {
			message("自然の浸食作用で削られたのか、"
					"神殿の建設者によるものかわからないが、"
					"ドーム状の天井になっている。");
		}
        return 1;
    default:
        *exist = 0;
        break;
    }
    return 0;
}


int command_callback_cast_spell(char *line){

    strip_space(line);
    printf("spell:%s:\n", line);
    // 呪文が違ったらなにも起こらない
#ifdef DEBUG
    if (strcmp(line, DEBUG_JSPELL) != 0 && strcmp(line, JSPELL) != 0 &&
        strcmp(line, DEBUG_ESPELL) != 0 && strcmp(line, ESPELL) != 0)
    {
#else 
        if (strcmp(line, JSPELL) != 0 && strcmp(line, ESPELL) != 0){
#endif
        msg_no_effect();
        return 0;
    }
    message("あなたが呪文を唱え始めると、眼前のそれは、"
            "わずかにたじろいだかに見えた。");
    if (Not(magic_circle_invoked) || Not(cycrotron_activated)){
        message("しかし、\\");
        msg_no_effect();
        return 0;
    }
    // とりあえず呪文が効果を発揮し始める
    message("あなたの言葉と共に、天井の魔法陣が強く光り輝き、"
            "神殿内が強い力で満たされていくのを感じる。");
    set_wait_return_callback(callback_invoke_projected_circle);
    // 以後のreturn_callback中、プロンプトを初期化されないよう
    // command_callback継続中に見せかける
    // command_callbackはreturn_callbackを終えるときに手動でクリアする
    return 1;
}
void callback_invoke_projected_circle(void){
    if (HasNot(amulet)){
        message("しかし、呪文を唱え終えると同時に光は消え失せ、"
                "周りを満たしていた力もそのまま去っていった。");
        // コマンドコールバック継続に見せかけているので手動でクリア
        clear_command_callback();
        return;
    }
    message(""
            "呪文を唱え終えるると同時に、魔法陣から放たれた光の束が、"
            "眼前のそれを貫いた。"
            "触手を振り回して悶える忌まわしい肉界の中から、"
            "引きずり出されるようにして巨大な異形の影が現れる。"
            "光の束は影を拘束するように絡みつくと、魔法陣へ引き寄せていった。");
    set_wait_return_callback(callback_sendback_great_old_one);
}
void callback_sendback_great_old_one(void){
    message(""
            "冒涜的な姿の影が、もがきながら魔法陣の中に姿を消すと、"
            "魔法陣も光を失い、消えていった。"
            "後には、支配者の抜け殻となった名状し難い肉塊だけが残された。");
    Set(great_old_one_gone);
    set_wait_return_callback(callback_remove_water);
}
void callback_remove_water(void){
    message(""
            "すべてが終わったと思ったとき、"
            "残された肉塊が狂ったようにもがき始めた。"
            "触手が壁に叩きつけられ、"
            "奇妙な形をした柱が砕け散る。"
			"触手の1本があなたを襲い、危うく躱したものの、"
			"崩れ落ちた瓦礫によって戻り道が塞がれてしまった。");
    message("気が付くと、どこかに亀裂が入ったのか溜まっていた水が流れ出し、"
            "神殿の床が姿を現していた。");
    Set(temple_unsunken);
    // コマンドコールバック継続に見せかけているので手動でクリア
    clear_command_callback();
}

void post_temple(int time_passed){
	if (!time_passed) return;
    if (Is(temple_unsunken) && Not(temple_ceiling_destroyed)){
		message(""
				"暴れ狂う触手に幾度も打ちのめされ、"
				"ついに天井が崩れ落ちた。");
		message("瓦礫と共に落下してきた車が肉塊にぶつかり、"
                "ガソリンをまき散らしながら床の上に転がった。"
                "積まれていたドラム缶のいくつかが潰れ、"
                "床の上に広がっていく。");
                //				"潰れたドラム缶から流れ出したガソリンが"
                //				"肉塊を伝って床の上に広がった。");
		Set(temple_ceiling_destroyed);
	}
}

#if 0
}
#endif
