#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_under_tree(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch (vid){
        case vi_look:
            DescribeArea;
			message("大きな%nlが立っている。",
					ni_tree);
            return 1;
        case vi_left:
            move_area(ai_backdoor);
            return 1;
        case vi_right:
            move_area(ai_garden);
            return 1;
		case vi_up:
			message("手に届くところに枝がない。"
					"木登り名人を連れてくるか、"
					"梯子でも用意しないと無理だろう。");
			return 1;
        default:
            break;
        }
        break;
	case ni_tree:
		switch (vid){
		case vi_look:
		case vi_examine:
			message("枝の一本が、窓を突き破って屋敷の中に入り込んでいる。");
			return 1;
		case vi_up:
			RedoArea(vid, ni_invalid);
		default:
			break;
		}
		break;
	case ni_window:
		switch (vid){
		case vi_look:
		case vi_examine:
			RedoArea(vid, ni_tree);
			return 1;
		case vi_open:
		case vi_close:
		case vi_push:
		case vi_pull:
		case vi_move:
		case vi_remove:
		case vi_hit:
		case vi_kick:
		case vi_destroy:
		case vi_enter:
		case vi_up:
			message("窓に手が届かない。");
			return 1;
		default:
			break;
		}
		break;
	case ni_wall:
		break;
    default:
    	*exist = 0;
        break;
    }
    return 0;
}
