#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_washtub(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("目の前には大きな%nlがあり、"
					"その上には%nlがある。",
					ni_washtub, ni_window);
            return 1;
        case vi_left:
            move_area(ai_opened_window);
            return 1;
        case vi_right:
            move_area(ai_backdoor);
            return 1;
		case vi_up:
			message("%nnの細い縁に立つのは至難の業だ。",
					ni_washtub);
			return 1;
        default:
            break;
        }
        break;
    case ni_washtub:
		switch (vid){
		case vi_look:
			message("大きな%nnだ。"
					"中にはたっぷりと%nlが溜まっている。",
					ni_washtub, ni_water);
			return 1;
		case vi_examine:
			message("木で作られた、年代物のようだ。");
			return 1;
		case vi_move:
		case vi_remove:
		case vi_get:
			msg_too_heavy();
			return 1;
		case vi_up:
			RedoArea(vid, ni_invalid);
		default:
			break;
		}
		break;
    case ni_water:
		switch (vid){
		case vi_look:
		case vi_examine:
			message("雨水が溜まったものだろうか。澄んだ水だ。");
			return 1;
		case vi_get:
			message("いい考えだが、あいにく適当な容器がない。");
			return 1;
		case vi_drink:
			message("あなたはごくごくと水を飲んだ。"
					"腹を壊さないとよいが…。");
			return 1;
		default:
			break;
		}
		break;
    case ni_window:
		switch (vid){
		case vi_look:
		case vi_examine:
			message("一部ガラスが割れて穴が開いている。");
			return 1;
		default:
			break;
		}
		break;
    case ni_wall:
        break;
    default:
    	*exist = 0;
        break;
    }
    return 0;
}
