#ifndef CONFIG_H
#define CONFIG_H
#include <assert.h>
// EzGraph-Win32でprintfなどを有効にするためには、printfする全ファイルでEzGraph.hが必要	
#include <EzGraph.h>

#define MAJOR_VERSION 0
#define MINOR_VERSION 85

#define SAVE_DIR ".mastery"
#define SAVE_FILE "mastery.sav"
#define ACHIEVEMENTS_FILE "achievements.sav"
#define CONFIG_FILE "mastery.cfg"

#define APPLICATION_ID "\0MASTERY"
#define APPLICATION_ID_SIZE 8

#define LOG_FILE "mastery.log"

// とりあえずここで指定。将来的にMakefileに移動
//#define CODE_SJIS
//#define CODE_EUC


#define CURSOR '_'
#define DEFAULT_PROMPT ">"
#define QUERY_PROMPT "?"

//#define DEFAULT_INPUT_MODE im_english
#define DEFAULT_INPUT_MODE im_hiragana
//#define DEFAULT_INPUT_MODE im_katakana

// messageに与える文字列の最大長
#define MESSAGE_MAX_LEN (1024 * 16)

#define MESSAGE_QUEUE_MAX_LEN 16

//#define NOUN_MAX_NUM 256
//#define VERB_NUM_MAX 256
#define WORD_MAX_NUM 1024
// ヒストリ登録可能数+1
#define HISTORY_SIZE (8+1)


#define FONT "-ricoh-mincho-medium-r-normal--%d-*-*-*-p-*-jisx0201.1976-*,"\
    "-ricoh-mincho-medium-r-normal--%d-*-*-*-p-*-jisx0208.1983-*,"\
    "-ricoh-mincho-medium-r-normal--%d-*-*-*-p-*-iso8859-*"

#endif


