#include <stdio.h>
#include <stdlib.h>
#include <EzGraph.h>
#include "config.h"
#include "layout.h"
#include "main.h"
#include "graphic.h"
#include "term.h"
#include "command.h"
#include "area.h"
#include "map.h"
#include "status.h"
#include "game_config.h"
//#include "uty.h"
#include "getarg.h"
#include "file.h"


int main(int argc, char *argv[]){
    EzOpenWindow(CLIENT_WIDTH, CLIENT_HEIGHT);
    init(argc, argv);
    EzEventLoop();
    final();
    return 0;
}


void init(int argc, char *argv[]){

    if (getarg(argc, argv) != 0){
        exit(1);
    }
    file_init(argv[0], get_opt_str("savedir"), SAVE_DIR, LOG_FILE);

    EzSetFontSize(FONT_SIZE);
    //	EzSetColorByRGB(255,255,0);
    EzSetMouseHandler(mouseh);
#ifdef FONT
    EzSetFont(FONT);
#endif    
	init_graphic();
    term_init(CONSOLE_BUFFER_LINES, CONSOLE_CHR_WIDTH, CONSOLE_CHR_HEIGHT-1);
	init_command();
	init_area();
    init_map();
    status_init();
    // 各モジュール初期化(およびデフォルト値設定後)にCFGファイルを読み込む
    if (!load_config()){
        log_warn("Loading '%s/%s' failed.\n",
                 get_save_dpath(), CONFIG_FILE);
    }
    //    init_uty(argv[0]);
    move_to_title();
	draw_screen();
}

void final(void){
    if (!save_config()){
        log_warn("Saving '%s/%s' failed.\n",
                 get_save_dpath(), CONFIG_FILE);
    }
}

// 右クリックで終了してしまわないよう、マウスクリックをトラップ
void mouseh(int x, int y, unsigned int n){
}
