#ifndef MAP_H
#define MAP_H

#include "area.h"
#include "status.h"

typedef enum {
    di_up, di_down, di_right, di_left, di_upright, di_upleft, di_downleft,
} dir_t;

typedef struct {
    int x, y;
} pos_t;

typedef int map_id_t;
#define INVALID_MAP_ID (-1)


#define CMD_MAX 8
#define POS_MAX (CMD_MAX*2)


typedef struct {
    area_id_t aid;
    //    flag_id_t fid;
    int level;
    char cmd[CMD_MAX+1];
    pos_t pos[POS_MAX];
    pos_t apos;
    dir_t dir;
} map_area_t;




void init_map(void);
void draw_minimap_line(int sx, int sy, int ex, int ey);
void draw_minimap_box(int sx, int sy, int ex, int ey);
void draw_minimap(void);
void draw_minimap_arrow(map_id_t mid);
void toggle_show_minimap(void);
void toggle_minimap_location(void);
void toggle_overlay_minimap(void);
int is_minimap_shown(void);
int is_overlay_minimap(void);
int get_minimap_location(void);
void set_show_minimap(int val);
void set_overlay_minimap(int val);
void set_minimap_location(int val);
#endif
