#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"
#include "noun.h"
#include "status.h"
#include "message.h"
#include "layout.h"
#include "history.h"
#include "term.h"


static noun_t nouns[] = {
	{ni_invalid, "", {"", "", ""}, ""},
    {ni_newspaper, "新聞の切り抜き", 
     {"newspaper", "しんぶん", "シンブン"},
     ""
    },
    {ni_leaflet, "チラシ", 
     {"leaflet", "ちらし", "チラシ"},
     "講演会のチラシのようだ。"
     //     "宛先はヨシノ教授となっている。"
     //     "差出人はラブク…字がかすれて読めない。"
     //     "よく見るとすでに封が切られている。"
    },
    {ni_medal, "メダル",
     {"medal", "めだる", "メダル"},
     "星形をした金属製のメダルだ。"
    },
    {ni_brass_key, "真鍮の鍵", 
     {"brass key", "しんちゅうのかぎ", "シンチュウノカギ"},
     "真鍮製の鍵だ。"
    },
    {ni_wooden_key, "木の鍵", 
     {"wooden key", "きのかぎ", "キノカギ"}, 
     "木製の玩具のような鍵だ。"
    },
    {ni_bronze_key, "青銅の鍵", 
     {"bronze key", "せいどうのかぎ", "セイドウノカギ"}, 
     "青銅製の鍵だ。"
    },
    {ni_steel_key, "鉄の鍵", 
     {"steel key", "てつのかぎ", "テツノカギ"}, 
     "鉄の鍵だ。"
    },
    {ni_golden_key, "金色の鍵", 
     {"golden key", "きんのかぎ", "キンノカギ"}, 
     "小さな金メッキされた鍵だ。"
    },
    {ni_silver_key, "銀の鍵", 
     {"silver key", "ぎんのかぎ", "ギンノカギ"}, 
     "銀で作られた鍵だ。"
    },
    {ni_glasses, "眼鏡", 
     {"glasses", "めがね", "メガネ"}, 
     "眼鏡だ。"
    },
    {ni_necklace, "首飾り", 
     {"necklace", "くびかざり", "クビカザリ"}, 
     "上品な首飾りだ。"
    },
    {ni_clothes, "衣類",
     {"clothes", "ふく", "フク"},
     "衣類だ。"
    },
    {ni_chicken, "鶏の丸焼き",
     {"roast chicken", "まるやき", "マルヤキ"},
     "鶏の丸焼きだ。"
    },
    {ni_chicken_bone, "鶏の骨",
     {"chicken bone", "とりのほね", "トリノホネ"},
     "鶏の骨だ。"
    },
    {ni_human_bone, "骨",
     {"bone", "ほね", "ホネ"},
     "マクドナルドとおぼしき人物の足の骨だ。"
    },




	{ni_rubber_duck, "ゴムのアヒル", 
     {"duck", "あひる", "アヒル"}, 
     "ゴム製のアヒルの玩具だ。"
    },
    {ni_mirror, "鏡",
     {"mirror", "かがみ", "カガミ"},
     "浴室の鏡だ。"
    },
    {ni_screw, "ねじ",
     {"screw", "ねじ", "ネジ"},
     "鏡を固定していた金属製のねじだ。"
    },
    {ni_screwdriver, "ねじ回し",
     {"screwdriver", "ねじまわし", "ネジマワシ"},
     "ねじを回すための工具だ。"
    },
    {ni_toy_swordman, "玩具の剣士", 
     //     {"toy swordman", "おもちゃのけんし", "オモチャノケンシ"},
     {"swordman", "けんし", "ケンシ"},
     "剣を構えたロボットの玩具だ。教授の息子のものだろう。"
    },
    {ni_toy_lion, "玩具のライオン",
     //     {"toy lion", "おもちゃのらいおん", "オモチャノライオン"},
     {"lion", "らいおん", "ライオン"},
     "ライオン型メカの玩具だ。教授の息子のものだろう。"
    },
    {ni_toy_bird, "玩具の鳥",
     //     {"toy bird", "おもちゃのとり", "オモチャノトリ"}, 
     {"bird", "とり", "トリ"}, 
     "鳥型メカの玩具だ。教授の息子のものだろう。"
    },
    {ni_robot, "玩具のロボット",
     {"robot", "ろぼっと", "ロボット"},
     "玩具を三体合体させたものだ。"
    },
    {ni_toy_dragon, "玩具のドラゴン",
     //     {"toy dragon", "おもちゃのどらごん", "オモチャノドラゴン"},
     {"dragon", "どらごん", "ドラゴン"},
     "ドラゴン型メカのおもちゃだ。教授の息子のものだろう。"
    },
    {ni_large_robot, "玩具の巨大ロボット",
     {"large robot", "きょだいろぼっと", "キョダイロボット"},
     "玩具のロボットとドラゴンを合体させたものだ。"
    },
    {ni_plush_cat, "ぬいぐるみ",
     {"plush cat", "ぬいぐるみ", "ヌイグルミ"},
     "猫のぬいぐるみだ。"
    },
    {ni_girl_doll, "少女の人形",
     {"doll", "にんぎょう", "ニンギョウ"},
     "赤髪のお下げをした少女の人形だ。教授の娘のものだろう。"
    },
    {ni_witch_doll, "魔女の人形",
     {"witch", "まじょ", "マジョ"},
     "魔女の人形だ。"
    },
    {ni_slingshot, "ぱちんこ",
     {"slingshot", "ぱちんこ", "パチンコ"},
     "ぱちんこだ。"
    },
    {ni_rubber_strip, "ゴムひも",
     {"rubber strip", "ごむひも", "ゴムヒモ"},
     "ぱちんこのゴムひもだ。"
    },
    {ni_branch, "小枝",
     {"branch", "こえだ", "コエダ"},
     "二股に分かれた木の小枝だ。"
    },
    {ni_marble, "ビー玉",
     {"marble", "びーだま", "ビーダマ"},
     "ガラスの小さな玉だ。"
    },
    {ni_poker, "火かき棒",
     {"poker", "ひかきぼう", "ヒカキボウ"},
     "暖炉の火かき棒だ。"
    },





    {ni_billiard_ball, "ビリヤードボール",
     {"billiard ball", "びりやーどぼーる", "ビリヤードボール"},
     "ビリヤードの玉だ。"
    },
    {ni_logbook, "日誌",
     {"logbook", "にっし", "ニッシ"},
     "看護日誌だ。"
    },
    {ni_diary, "日記帳",
     {"diary", "にっき", "ニッキ"},
     "日記帳だ。"
    },
    //    {ni_diary_piece, "日記のページ",
    //     {"diary piece", "にっきのぺーじ", "ニッキノページ"},
    //     "紙飛行機を開いた紙切れだ。日記帳のページを破いたもののようだ。"
    {ni_paper, "紙",
     {"paper", "かみ", "カミ"},
     "紙飛行機を開いた紙切れだ。"
    },
    {ni_origami_plane, "紙飛行機",
     {"origami plane", "かみひこうき", "カミヒコウキ"},
     "紙を折って作った飛行機だ。"
    },
    {ni_bottle, "小瓶",
     {"bottle", "こびん", "コビン"},
     "不思議な文様の施された小瓶だ。"
    },
    {ni_amulet, "奇妙な石",
     {"stone", "いし", "イシ"},
     "何か彫刻された小さな石だ。"
    },
    {ni_score, "楽譜",
     {"score", "がくふ", "ガクフ"},
     "楽譜だ。"
    },
    {ni_easy_necromancy, "『猫でもわかる交霊術』",
     {"necromancy", "こうれいじゅつ", "コウレイジュツ"},
     "初心者向けの交霊術の本だ。"
    },
    {ni_another_world, "『異界の存在とその召喚』",
     {"another world", "いかい", "イカイ"},
     "我々とは異なる世界の住民と、それを呼び出す方法が書かれている。"
    },
    {ni_essay, "作文",
     {"essay", "さくぶん", "サクブン"},
     "子供が書いた作文だ。"
    },
    {ni_wastepaper, "紙屑",
     {"wastepaper", "かみくず", "カミクズ"},
     "丸めた紙屑のようだ。"
    },
    {ni_fishing_rod, "釣り竿",
     {"fishing rod", "つりざお", "ツリザオ"},
     "魚釣り用の釣り竿だ。"
    },
    {ni_sponge, "スポンジ",
     {"sponge", "すぽんじ", "スポンジ"},
     "入浴用のスポンジだ。"
    },
    {ni_fossil, "化石",
     {"fossil", "かせき", "カセキ"},
     "立派なアンモナイトの化石だ。"
    },
    {ni_postcard, "葉書",
     {"postcard", "はがき", "ハガキ"},
     "郵便葉書だ。"
    },
    {ni_lantern, "ランタン",
     {"lantern", "らんたん", "ランタン"},
     "持ち歩き用のランタンだ。"
    },
    {ni_ladder, "梯子", 
     {"ladder", "はしご", "ハシゴ"}, 
     "二段ベッドの梯子だ。"
    },
    {ni_candle, "蝋燭", 
     {"candle", "ろうそく", "ロウソク"}, 
     "大きな蝋燭だ。"
    },




    {ni_cuckoo, "木彫りの小鳥",
     {"cuckoo", "はと", "ハト"},
     "木彫りの小鳥の像だ。"
    },




	
	
    {ni_water, "水", 
     {"water", "みず", "ミズ"}, 
     "水だ。"
    },
    {ni_belt, "首輪",
     {"belt", "べると", "ベルト"},
     "革製の首輪だ。"
    },
    {ni_note, "メモ",
     {"note", "めも", "メモ"},
     "何か書いてある。"
    },
    {ni_pocket_notebook, "手帳",
     {"pocket notebook", "てちょう", "テチョウ"},
     "手帳だ。"
    },
    {ni_notebook, "ノート",
     {"notebook", "のーと", "ノート"},
     "ノートだ。"
    },
    //    {ni_paper, "紙切れ",
    //     {"paper", "かみ", "カミ"},
    //     "紙切れだ。"
    //    },
    //    {ni_card, "トランプ",
    //     {"card", "とらんぷ", "トランプ"},
    //     "トランプのカードだ。"
    //    },
    {ni_hat, "帽子",
     {"hat", "ぼうし", "ボウシ"},
     "鹿撃ち帽だ。"
    },


    /*
    {ni_note, "手記",
     {"note", "しゅき", "シュキ"},
     "小さなノートに書かれた手記だ。"
     },*/

// 汎用名詞(基本的には、文中で単語を示さない)
    {ni_door, "扉", 
     {"door", "とびら", "トビラ"},
     "普通の扉だ。"
    },
    {ni_wall, "壁", 
     {"wall", "かべ", "カベ"},
     "普通の壁だ。"
    },
    {ni_window, "窓", 
     {"window", "まど", "まど"},
     "普通の窓だ。"
    },
    {ni_floor, "床", 
     {"floor", "ゆか", "ユカ"},
     "普通の床だ。ほこりが積もっている。"
    },
    {ni_ceiling, "天井", 
     {"ceiling", "てんじょう", "テンジョウ"},
     "普通の天井だ。"
    },
    {ni_stairs, "階段", 
     {"stairs", "かいだん", "カイダン"},
     "普通の階段だ。"
    },
    {ni_room, "部屋", 
     {"room", "へや", "ヘヤ"},
     "部屋だ。"
    },
    {ni_corridor, "廊下", 
     {"corridor", "ろうか", "ロウカ"},
     "廊下だ。"
    },

// 汎用名詞(複数場面で登場するが、文中で単語を示す)
// 場面により見た目が異なる可能性があるので、descriptionで詳しい描写はしない
    {ni_front_door, "正面の扉", 
     {"front door", "まえのとびら", "マエノトビラ"},
     "正面にある扉だ。"
    },
    {ni_back_door, "背後の扉", 
     {"back door", "うしろのとびら", "ウシロノトビラ"},
     "背後にある扉だ。"
    },
    {ni_left_door, "左側の扉", 
     {"left door", "ひだりのとびら", "ヒダリノトビラ"},
     "左側にある扉だ。"
    },
    {ni_right_door, "右側の扉", 
     {"right door", "みぎのとびら", "ミギノトビラ"},
     "右側にある扉だ。"
    },
	{ni_table, "テーブル",
     {"table", "てーぶる", "テーブル"},
     "テーブルだ。"
    },
	{ni_chair, "椅子",
     {"chair", "いす", "イス"},
     "椅子だ。"
    },
    {ni_bed, "ベッド",
     {"bed", "べっど", "ベッド"},
     "ベッドだ。"
    },
    {ni_mattress, "マットレス",
     {"mattress", "まっとれす", "マットレス"},
     "ベッドのマットレスだ。"
    },
    {ni_desk, "机",
     {"desk", "つくえ", "ツクエ"},
     "机だ。"
    },
    {ni_drawer, "抽斗",
     {"drawer", "ひきだし", "ヒキダシ"},
     "抽斗だ。"
    },
    {ni_bookshelf, "本棚",
     {"bookshelf", "ほんだな", "ホンダナ"},
     "本棚だ。"
    },
    {ni_front_bookshelf, "正面の本棚", 
     {"front bookshelf", "まえのほんだな", "マエノホンダナ"},
     "正面にある本棚だ。"
    },
    {ni_left_bookshelf, "左側の本棚", 
     {"left bookshelf", "ひだりのほんだな", "ヒダリノホンダナ"},
     "左側にある本棚だ。"
    },
    {ni_right_bookshelf, "右側の本棚", 
     {"right bookshelf", "みぎのほんだな", "ミギノホンダナ"},
     "右側にある本棚だ。"
    },
    {ni_chain, "鎖", 
     {"chain", "くさり", "クサリ"},
     "細い金属の鎖だ。"
    },
    {ni_box, "箱", 
     {"box", "はこ", "ハコ"},
     "箱だ。"
    },
    {ni_cabinet, "キャビネット", 
     {"cabinet", "きゃびねっと", "キャビネット"},
     "キャビネットだ。"
    },
    {ni_chest, "箪笥", 
     {"chest", "たんす", "タンス"},
     "箪笥だ。"
    },
    {ni_book, "本", 
     {"book", "ほん", "ホン"},
     "本だ。"
    },
    {ni_handle, "取っ手", 
     {"handle", "とって", "トッテ"},
     "取っ手だ。"
    },
    {ni_letter, "手紙", 
     {"letter", "てがみ", "テガミ"},
     "手紙だ。"
    },



// 各場面固有の名詞(基本的に、ゲーム中に一つずつしか存在しない)
	{ni_house, "屋敷",
     {"house", "いえ", "イエ"},
     "旧マクドナルド邸だ"
    },
	{ni_path, "小道",
     {"path", "こみち", "コミチ"},
     "館の玄関まで続く、石畳の小道だ。"
    },
    {ni_mailbox, "郵便受け", 
     {"mailbox", "ゆうびんうけ", "ユウビンウケ"},
     ""
    },
    {ni_flowerpot, "植木鉢", 
     {"flowerpot", "うえきばち", "ウエキバチ"},
     "素焼きの植木鉢だ。"
    },
    {ni_bathtub, "浴槽", 
     {"bathtub", "よくそう", "ヨクソウ"},
     "浴槽だ。縁にほこりが積もっている。"
    },
    {ni_washstand, "洗面台", 
     {"washstand", "せんめんだい", "センメンダイ"},
     "洗面台だ。ほこりが積もっている。"
    },
    {ni_toilet, "便器", 
     {"toilet", "べんき", "ベンキ"},
     "洋式便器だ。ほこりが積もっている。"
    },
    {ni_washer, "洗濯機", 
     {"washer", "せんたくき", "センタクキ"},
     "洗濯機だ。"
    },
    {ni_dryer, "乾燥機", 
     {"dryer", "かんそうき", "カンソウキ"},
     "乾燥機だ。"
    },
    {ni_dog, "犬",
     {"dog", "いぬ", "イヌ"},
     "強そうな大型犬だ。"
    },
    {ni_orion, "オリオン",
     {"Orion", "おりおん", "オリオン"},
     "サンダース大佐の犬のようだ。"
    },
    {ni_treasure_chest, "宝箱",
     {"treasure chest", "たからばこ", "タカラバコ"},
     "子供用の玩具の宝箱だ。"
    },



    {ni_fireplace, "暖炉",
     {"fireplace", "だんろ", "ダンロ"},
     "煉瓦作りの暖炉だ。"
    },
    {ni_tv, "テレビ",
     {"TV", "てれび", "テレビ"},
     "ブラウン管のテレビだ。"
    },
    {ni_telephone, "電話機",
     {"telephone", "でんわ", "デンワ"},
     "古い電話機だ。"
    },
    {ni_clock, "時計",
     {"clock", "とけい", "トケイ"},
     "時計だ。"
    },
    {ni_clock_hands, "針",
     {"clock hands", "はり", "ハリ"},
     "時計の針だ。"
    },
    {ni_photo, "写真",
     {"photo", "しゃしん", "シャシン"},
     "家族の集合写真だ。"
    },
    {ni_man, "男性",
     {"man", "おとこ", "オトコ"},
     "眼鏡をかけた、アジア系の穏やかそうな風貌の人物だ。"
     "おそらくヨシノ教授だろう。"
    },
    {ni_woman, "女性",
     {"woman", "おんな", "オンナ"},
     "やさしそうな女性だ。教授の妻だろうか。"
    },
    {ni_girl, "少女",
     {"girl", "おんなのこ", "オンナノコ"},
     "中学生ぐらいの少女だ。教授の娘だろう。"
     }, 
    {ni_boy, "少年", 
     {"boy", "おとこのこ", "オトコノコ"}, 
     "小学生ぐらいの少年だ。教授の息子だろう。" 
     "巨大なロボットの玩具を抱えて満足そうに笑っている。" 
    }, 
    {ni_ash, "燃えかす", 
     {"ash", "もえかす", "モエカス"}, // ※ただの「はい」だとni_yesと重なるため 
     "薪が燃えたあとの残りかすだ。" 
    },
    {ni_videotape, "ビデオテープ",
     {"videotape", "びでおてーぷ", "ビデオテープ"},
     "市販のビデオソフトだ。"
    },
    

    {ni_counter, "調理台",
     {"counter", "ちょうりだい", "チョウリダイ"},
     "調理台だ。"
    },
    {ni_sink, "流し台",
     {"sink", "ながしだい", "ナガシダイ"},
     "流し台だ。"
    },
    {ni_range, "ガスコンロ",
     {"range", "こんろ", "コンロ"},
     "ガスコンロだ。"
    },
    {ni_oven, "オーブン",
     {"oven", "おーぶん", "オーブン"},
     "ガスオーブンだ。"
    },
	{ni_icebox, "冷蔵庫",
     {"icebox", "れいぞうこ", "レイゾウコ"},
     "冷蔵庫だ。"
    },
	{ni_cupboard, "食器棚",
     {"cupboard", "しょっきだな", "ショッキダナ"},
     "食器棚だ。"
    },
	{ni_billiard_table, "ビリヤード台",
     {"billiard table", "びりやーどだい", "ビリヤードダイ"},
     "ビリヤード台だ。"
    },
	{ni_darts_target, "ダーツの的",
     {"target", "まと", "マト"},
     "ダーツの的だ。"
    },

    {ni_portrait, "肖像画",
     {"portrait", "え", "エ"},
     "女性の肖像画だ。"
    },

    {ni_washtub, "洗い桶",
     {"washtub", "おけ", "オケ"},
     "木製の大きな洗い桶だ。"
    },
    {ni_tree, "木",
     {"tree", "き", "キ"},
     "木だ。"
    },
    {ni_car, "車",
     {"car", "くるま", "クルマ"},
     "ピックアップトラック型の自家用車だ。"
    },
    {ni_drum, "ドラム缶",
     {"drum", "どらむかん", "ドラムカン"},
     "ドラム缶だ。"
    },
    {ni_garden, "庭園",
     {"garden", "ていえん", "テイエン"},
     "荒れ果てた庭園だ。"
    },




    {ni_wardrobe, "洋服箪笥",
     {"wardrobe", "ようふくだんす", "ヨウフクダンス"},
     "立派な洋服箪笥だ。中に入れそうなほど大きい。"
    },
    {ni_dressing_table, "化粧台",
     {"dressing table", "けしょうだい", "ケショウダイ"},
     "化粧台だ。鏡の部分は粉々に割れている。"
    },
    {ni_piano, "ピアノ",
     {"piano", "ぴあの", "ピアノ"},
     "古いグランドピアノだ。"
    },
    // 鎧内部の魔法陣と隠し部屋の魔法陣を兼用
    {ni_magic_circle, "魔法陣",
     {"magic circle", "まほうじん", "マホウジン"},
     "魔法陣だ。"
    },
    {ni_altar, "祭壇",
     {"altar", "さいだん", "サイダン"},
     "祭壇だ。"
    },
    {ni_passage, "通路",
     {"passage", "つうろ", "ツウロ"},
     "通路だ。"
    },
    {ni_skeleton, "骸骨",
     {"skeleton", "がいこつ", "ガイコツ"},
     "白骨死体だ。"
    },
    {ni_skull, "髑髏",
     {"skull", "どくろ", "ドクロ"},
     "髑髏だ。"
    },
    {ni_gun, "ショットガン",
     {"shotgun", "じゅう", "ジュウ"},
     "ショットガンだ。"
    },

    {ni_hatch, "ハッチ", 
     {"hatch", "はっち", "ハッチ"},
     "床に取り付けられたハッチだ。"
    },
    {ni_machine, "機械", 
     {"machine", "きかい", "キカイ"},
     "見たことのない機械だ。"
    },
    {ni_button, "ボタン", 
     {"button", "ぼたん", "ボタン"},
     "ボタンだ。"
    },
    {ni_green_button, "緑色のボタン", 
     {"green button", "みどりのぼたん", "ミドリノボタン"},
     "大きな緑色のボタンだ。"
    },
    {ni_red_button, "赤色のボタン", 
     {"red button", "あかいぼたん", "アカイボタン"},
     "大きな赤色のボタンだ。"
    },
    {ni_panel, "パネル", 
     {"panel", "ぱねる", "パネル"},
     "金属のパネルだ。"
    },
    {ni_round_door, "丸扉", 
     {"round door", "まるとびら", "マルトビラ"},
     "金属の丸い扉だ。"
    },
    {ni_small_door, "小さな扉", 
     {"small door", "ちいさなとびら", "チイサナトビラ"},
     "金属の小さな扉だ。"
    },
    {ni_cable, "ケーブル", 
     {"cable", "けーぶる", "ケーブル"},
     "ビニールで被覆されたケーブルだ。"
    },
    {ni_fuel_rod, "金属棒", 
     {"rod", "ぼう", "ボウ"},
     "金属の棒をいくつか束ねたものだ。"
    },
    {ni_it, "支配者", 
     {"it", "しはいしゃ", "シハイシャ"},
     "名状しがたい肉塊のような存在だ。"
    },
    {ni_face, "顔", 
     {"face", "かお", "カオ"},
     "肉塊に浮かび上がった、人の顔だ。"
    },
    {ni_tentacle, "触手", 
     {"tentacle", "しょくしゅ", "ショクシュ"},
     "人の胴ほどの太さのある、巨大な触手だ。"
    },
    {ni_spell, "呪文", 
     {"spell", "じゅもん", "ジュモン"},
     "異界の存在を送還する呪文だ。"
    },

    {ni_bathroom_1f_wall, "一階浴室", 
     {"1f bathroom", "いっかいよくしつ", "イッカイヨクシツ"},
     ""
    },
    {ni_bathroom_2f_wall, "二階浴室", 
     {"2f bathroom", "にかいよくしつ", "ニカイヨクシツ"},
     ""
    },
    {ni_study_note, "書斎の手記", 
     {"study note", "しょさいのしゅき", "ショサイノシュキ"},
     ""
    },
    {ni_secret_room_note, "隠し部屋の手記", 
     {"secret room note", "かくしべやのしゅき", "カクシベヤノシュキ"},
     ""
    },
    {ni_secret_room_book, "隠し部屋の本", 
     {"secret room book", "かくしべやのほん", "カクシベヤノホン"},
     ""
    },
    {ni_secret_room_letter, "隠し部屋の手紙", 
     {"secret room letter", "かくしべやのてがみ", "カクシベヤノテガミ"},
     ""
    },
    {ni_boiler_room_note, "ボイラー室", 
     {"boiler room", "ぼいらーしつ", "ボイラーシツ"},
     ""
    },





    {ni_armor, "鎧", 
     {"samurai armor", "よろい", "ヨロイ"},
     "日本の武士の鎧だ。教授の趣味だろうか。"
    },
    {ni_sword, "日本刀", 
     {"samurai sword", "かたな", "カタナ"},
     "日本刀だ。よく切れそうだ。"
    },



    {ni_noun, "名詞", 
     {"noun", "めいし", "メイシ"},
     NULL,
    },
    {ni_verb, "動詞", 
     {"verb", "どうし", "ドウシ"},
     NULL,
    },
    {ni_basic, "基本コマンド", 
     {"basic", "きほん", "キホン"},
     NULL,
    },
    {ni_tips, "ヒント", 
     {"tips", "ひんと", "ヒント"},
     NULL,
    },
    {ni_key, "キー操作", 
     {"key", "そうさ", "ソウサ"},
     NULL,
    },
    {ni_assistance, "補助機能", 
     {"assist", "ほじょ", "ホジョ"},
     NULL,
    },
    {ni_input, "入力", 
     {"input", "にゅうりょく", "ニュウリョク"},
     NULL,
    },
    {ni_english, "英語", 
     {"english", "えいご", "エイゴ"},
     NULL,
    },
    {ni_hiragana, "ひらがな", 
     {"hiragana", "ひらがな", "ヒラガナ"},
     NULL,
    },
    {ni_katakana, "カタカナ", 
     {"katakana", "かたかな", "カタカナ"},
     NULL,
    },
    {ni_yes, "肯定", 
     {"yes", "はい", "ハイ"},
     NULL,
    },
    {ni_no, "否定", 
     {"no", "いいえ", "イイエ"},
     NULL,
    },

#ifdef DEBUG
    {ni_entrance, "玄関", 
     {"entrance", "ゲンカン", "ゲンカン"},
     NULL,
    },
    {ni_entrance_hall, "玄関ホール", 
     {"hall", "ほーる", "ホール"},
     NULL,
    },
    {ni_living, "居間", 
     {"living", "いま", "イマ"},
     NULL,
    },
    {ni_dining, "食堂", 
     {"dining", "しょくどう", "ショクドウ"},
     NULL,
    },
    {ni_kitchen, "台所", 
     {"kitchen", "だいどころ", "ダイドコロ"},
     NULL,
    },
    {ni_bathroom, "浴室", 
     {"bathroom", "よくしつ", "ヨクシツ"},
     NULL,
    },
    {ni_boys_room, "男の子部屋", 
     {"boyroom", "こどもべや", "コドモベヤ"},
     NULL,
    },
    {ni_music_room, "音楽室", 
     {"music room", "おんがくしつ", "オンガクシツ"},
     NULL,
    },
    {ni_study, "書斎", 
     {"study", "しょさい", "ショサイ"},
     NULL,
    },
    {ni_library, "図書室", 
     {"library", "としょしつ", "トショシツ"},
     NULL,
    },
    {ni_cellar, "地下室", 
     {"cellar", "ちかしつ", "チカシツ"},
     NULL,
    },
    {ni_secret_room, "隠し部屋", 
     {"secret room", "かくしべや", "カクシベヤ"},
     NULL,
    },
    {ni_cave, "洞窟", 
     {"cave", "どうくつ", "ドウクツ"},
     NULL,
    },
    {ni_working_room, "ダミー部屋", 
     {"dummy", "だみー", "ダミー"},
     NULL,
    },
#endif
    /*
    {ni_, "", 
     {"", "", ""},
     NULL,
    },
    */
};

#define NOUN_NUM (sizeof(nouns)/sizeof(noun_t))

static esynonym_t esynonyms[] = {
    {"y", ni_yes},
    {"n", ni_no},
    {"television", ni_tv},
    {"photograph", ni_photo},
	{"refrigerator", ni_icebox},
	{"fridge", ni_icebox},
};

static jsynonym_t jsynonyms[] = {
	{"どあ", "ドア", ni_door},
    {"まえのどあ", "マエノドア", ni_front_door},
    {"うしろのどあ", "ウシロノドア", ni_back_door},
    {"ひだりのどあ", "ヒダリノドア", ni_left_door},
    {"みぎのどあ", "ミギノドア", ni_right_door},
	{"と", "ト", ni_door},
    {"まえのと", "マエノト", ni_front_door},
    {"うしろのと", "ウシロノト", ni_back_door},
    {"ひだりのと", "ヒダリノト", ni_left_door},
    {"みぎのと", "ミギノト", ni_right_door},
    {"といれ", "トイレ", ni_toilet},
    {"だんせい", "ダンセイ", ni_man},
    {"じょせい", "ジョセイ", ni_woman},
    {"しょうじょ", "ショウジョ", ni_girl},
    {"しょうねん", "ショウネン", ni_boy},
    {"ねこ", "ネコ", ni_plush_cat},
    {"ろぼ", "ロボ", ni_robot},
    {"きょだいろぼ", "キョダイロボ", ni_large_robot},
    {"しんだい", "シンダイ", ni_bed},
    {"ねっくれす", "ネックレス", ni_necklace},
    {"やしき", "ヤシキ", ni_house},
    {"びいだま", "ビイダマ", ni_marble},
    {"びりやあどぼおる", "ビリヤアドボオル", ni_billiard_ball},
    {"びりやあどだい", "ビリヤアドダイ", ni_billiard_table},
    //    {"くるま", "クルマ", ni_car},
    {"じどうしゃ", "ジドウシャ", ni_car},
    {"とらっく", "トラック", ni_car},
    {"にわ", "ニワ", ni_garden},
    {"どらいばー", "ドライバー", ni_screwdriver},
    {"あかのぼたん", "アカノボタン", ni_red_button},
    {"あかいろのぼたん", "アカイロノボタン", ni_red_button},
    {"みどりいろのぼたん", "ミドリイロノボタン", ni_green_button},
    {"まるいどあ", "マルイドア", ni_round_door},
    {"まるいと", "マルイト", ni_round_door},
    {"ちいさいとびら", "チイサイトビラ", ni_small_door},
    {"ちいさなどあ", "チイサナドア", ni_small_door},
    {"ちいさいどあ", "チイサイドア", ni_small_door},
    {"ちいさなと", "チイサナト", ni_small_door},
    {"ちいさいと", "チイサイト", ni_small_door},
    {"くびわ", "クビワ", ni_belt},
    {"にわとり", "ニワトリ", ni_chicken},
    {"ちきん", "チキン", ni_chicken},
    {"ひとのほね", "ヒトノホネ", ni_human_bone},
    {"にんげんのほね", "ニンゲンノホネ", ni_human_bone},
    {"まくどなるどのほね", "マクドナルドノホネ", ni_human_bone},
    {"あしのほね", "アシノホネ", ni_human_bone},
};

#define ESYNONYM_NUM (sizeof(esynonyms)/sizeof(esynonym_t))
#define JSYNONYM_NUM (sizeof(jsynonyms)/sizeof(jsynonym_t))

static dic_t noun_dic;
static history_t noun_hist;

int nid2noun_ix[ni_end];


void noun_init(void){
    int i, j;
    noun_id_t nid;

	assert(ni_item_end <= 256); // アイテムになる名詞IDは8bit以内

	init_dic(&noun_dic);
    init_history(&noun_hist);    
    
    // 基本名詞を辞書に登録
	// ※先頭のダミーは飛ばすので1から回す
    for (i = 1 ; i < NOUN_NUM ; i++){
        nid = nouns[i].id;
        if (nid2noun_ix[nid] != 0){
            printf("システムエラー: "
                   "名詞「%s」のID(%d)が"
                   "名詞「%s」のIDと重複しています\n", 
                   nouns[i].name, nid, nouns[nid2noun_ix[nid]].name);
            exit(1);
        }
        //        printf("set nid:%d ix:%d\n", nid, i);
        nid2noun_ix[nid] = i;
        for (j = 0 ; j < 3 ; j++){
            register_dic(&noun_dic, nouns[i].word[j], nouns[i].id);
        }
	}
    // 類義語を辞書に登録
    for (i = 0 ; i < ESYNONYM_NUM ; i++){
        register_dic(&noun_dic, esynonyms[i].word, esynonyms[i].id);
    }
    for (i = 0 ; i < JSYNONYM_NUM ; i++){
        register_dic(&noun_dic, jsynonyms[i].hiragana, jsynonyms[i].id);
        register_dic(&noun_dic, jsynonyms[i].katakana, jsynonyms[i].id);
    }	
	
	// データのないnidがないかチェック
	for (nid = ni_begin+1 ; nid < ni_end ; nid++){
        if (nid == ni_item_end ||
            nid == ni_generic_begin ||
            nid == ni_generic_end)
        {
            continue;
        }
        if (nid2noun_ix[nid] == 0){
            printf("システムエラー: "
				"nid:%dのデータがありません\n", nid);
            exit(1);
        }
    }
}

int get_noun_ix(char *word){
    return get_word_ix(word, &noun_dic);
}

noun_id_t get_noun_id(char *noun){
    int ix;
    noun_id_t nid = ni_unknown;

	if (noun == NULL) return ni_invalid;

    ix = get_noun_ix(noun);
    printf("get_noun_id %s:%d\n", noun, ix);
    register_noun_history(ix);
    if (ix >= 0){
        nid = word_ix2id(ix, &noun_dic);
    }
    return nid;
}
char *nid2noun(noun_id_t nid){
    input_mode_t mode = get_term_input_mode();
	int ix = nid2noun_ix[nid];

	if (ix > 0){
         return nouns[ix].word[mode];
    }
    return NULL;
}

char *noun_name(noun_id_t nid){
    //    printf("noun name %d(%d)\n", nid, nid2noun_ix[nid]);
    assert(nid2noun_ix[nid] > 0);

    return nouns[nid2noun_ix[nid]].name;
}
char *noun_description(noun_id_t nid){
    //    printf("nid:%d\n", nid);
    assert(nid2noun_ix[nid] > 0);

    return nouns[nid2noun_ix[nid]].description;
}

void register_noun_history(int noun_ix){
    register_history(noun_ix, &noun_hist);
}
char *get_history_noun(void){
	history_entry_t entry = noun_hist.entries[noun_hist.ix];
	if (entry.ix == INVALID_WORD_IX) return NULL;
	return ix2word(entry.ix, &noun_dic);
};
void prev_history_noun(void){
	prev_history(&noun_hist);
}
void next_history_noun(void){
	next_history(&noun_hist);
}

void show_help_noun(void){
    char buf[CONSOLE_CHR_WIDTH * CONSOLE_CHR_HEIGHT], *p, *word;
    noun_id_t nid;
    input_mode_t mode = get_term_input_mode();

    message("以下の一般的な名詞が使用できます。"
            "その他の名詞は、メッセージ中で'[', ']'内に示されます。");
    buf[0] = '\0';
    p = buf;

    for (nid = ni_generic_begin+1 ; nid < ni_generic_end ; nid++){
        word = nouns[nid2noun_ix[nid]].word[mode];
        strcpy(p, word);
        p += strlen(word);
        *p++ = ' ';
    }
    *p = '\0';
    puts(buf);
    puts_console(buf);
}

