#ifndef NOUN_H
#define NOUN_H
#include "dic.h"
#include "noun_id.h"


typedef struct {
    noun_id_t id;
    char *name;
    char *word[3];
    char *description;
} noun_t;


// nidの名詞がアイテムなら真を返す
#define IsNounItem(nid)  (nid > ni_item_begin && nid < ni_item_end)

void noun_init(void);
noun_id_t get_noun_id(char *noun);
char *nid2noun(noun_id_t nid);
char *noun_name(noun_id_t nid);
char *noun_description(noun_id_t nid);

void register_noun_history(int noun_ix);
char *get_history_noun(void);
void prev_history_noun(void);
void next_history_noun(void);

void show_help_noun(void);


#endif
